<?php
  /* HTML-Rahmen fuer BControl - in HTML5 - Design mit Aufklapp-Menüs links
   * Parameter:
   * GlobalVars(...)
   *    title    .. Titel fuer title
   *    header   .. Dateiname für Header-Inhalt (in ./view) oder "default"
   *    aside    .. Dateiname für Sidebar-Inhalt (in ./view)
   *    main     .. Dateiname für Main-Inhalt (in ./view)
   *    style    .. Array mit Dateinamen einzubindender Stylesheets (über style.css hinaus)
   *    script   .. Array mit Dateinamen einzubindender js-Scripte (über jQuery hinaus)
   */
?>
<!doctype html>
<html lang="de">
<head>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <link rel="stylesheet" type="text/css" media="all" href="./style/style.css?dmy=<?=GlobalVars::getVar("version")?>" />
<?php
    foreach (GlobalVars::getVar("style") as $ix => $style) {
?>      
    <link rel="stylesheet" type="text/css" media="all" href="./style/<?=$style?>?dmy=<?=GlobalVars::getVar("version")?>" />
<?php
    }
?>
    <link rel="icon" href="./img/app.png" sizes="16x16" type="image/png" />
    <title><?=GlobalVars::getVar("title")?></title>
</head>
 
<body>
    <script src="./script/jquery-3.1.1.min.js"></script>
<?php
    foreach (GlobalVars::getVar("script") as $ix => $script) {
?>      
    <script src="./script/<?=$script?>?dmy=<?=GlobalVars::getVar("version")?>"></script>
<?php
    }
?>
    <header>
        <img class="logo" src="./img/logo.png" alt="logo"
            width="64" height="64">
        <?php require("./view/".GlobalVars::getVar("header")); ?>
        <noscript>Javascript ist deaktiviert! Sie k&ouml;nnen nicht alle Funktionen nutzen!</noscript>
    </header>
<?php
    require("./view/".GlobalVars::getVar("aside"));
    require("./view/".GlobalVars::getVar("main"));
    require("./view/footer.php");

    foreach (GlobalVars::getVar("div") as $ix => $div) {
        require("./view/".$div);
    }
?>
    <div id="dump"></div>
</body>
</html>
