<?php
class KontoManager {
    static function getSaldo($konto, $datum) {
        $von1 = new Datum($datum->getDispFormat());
        $von1->addDays(-1);
        $sListe = self::getSaldenListe($konto, $von1, $datum);
        return $sListe["letzte"];
    }

    static function getSaldenListe($konto, $von, $bis) {
        $salden = array();
        $monat = new Monat($von);
        $von1 = $monat->getMonatsErster();
        $monat->setToVormonat();
        $saldo = ME_Saldo::getForMonat($konto, $monat)->getSaldo();
        $salden[0] = $saldo;
        $bListe = Buchung::findByParms($konto, "a", $von1, $bis);
        foreach ($bListe as $ix => $b) {
            $saldo += $b->getBetrag();
            $salden[$b->getId()] = $saldo;
            if ($b->getDatum()->isBefore($von))
                $salden[0] = $saldo;
            $salden["letzte"] = $saldo;
        }
        return $salden;
    }

    static function aktualisiereSalden($konto, $datum) {
        $monat = new Monat($datum);
        $von = $monat->getMonatsErster();
        $monat->setToVormonat();
        $saldo = ME_Saldo::getForMonat($konto, $monat)->getSaldo();
        $bListe = Buchung::findByParms($konto, "a", $von, new Datum("31.12.2099"));
        //BC_trace(" - KontoManager.aktualisiereSalden - von ".$von->getDispFormat()." - Saldo Vormonat (".$monat->getDispFormat().") = ".$saldo); // *** Trace
        $monat->setToFolgemonat();
        $bMonat = new Monat(0);
        foreach ($bListe as $ix => $b) {
            $bMonat->set($b->getDatum());
            if (!$monat->equals($bMonat)) {
                //BC_trace(" - KontoManager.aktualisiereSalden - Monatswechsel bei Buchung vom ".$b->getDatum()->getDispFormat()." (".$bMonat->getDispFormat().")"); // *** Trace
                $meSaldo = ME_Saldo::getForMonat($konto, $monat);
                $meSaldo->setSaldo($saldo);
                $meSaldo->save();
                //BC_trace(" - KontoManager.aktualisiereSalden --> ".$meSaldo->getMonat()->getDispFormat()." = ".$meSaldo->getSaldo()); // *** Trace
                $monat->set($bMonat->getAsNumber());
            }
            $saldo += $b->getBetrag();
        }
        $meSaldo = ME_Saldo::getForMonat($konto, $bMonat);
        $meSaldo->setSaldo($saldo);
        $meSaldo->save();
        //BC_trace(" - KontoManager.aktualisiereSalden --> ".$meSaldo->getMonat()->getDispFormat()." = ".$meSaldo->getSaldo()); // *** Trace
    }
}
?>