<?php
    // Aktion für Konto-Aufruf: Datums-Parameter-Handling
    Input::setSource("get");
    $von = Input::getString("von");
    if ($von != "") {
        // Datums-Bereich in Cookie merken ...
        $bis = Input::getString("bis");
        setcookie("bcKontoVon", $von, time()+60*60*24, "/");
        setcookie("bcKontoBis", $bis, time()+60*60*24, "/");
        // ... und in Datum-Objekte umsetzen
        $von = new Datum($von);
        $bis = new Datum($bis);
    } else if (isset($_COOKIE["bcKontoVon"])) {
        // Keine Parameter, aber Cookies --> aus Cookies holen
        $von = new Datum($_COOKIE["bcKontoVon"]);
        $bis = new Datum($_COOKIE["bcKontoBis"]);
    } else {
        // Keine Parameter, keine Cookies --> Defaults setzen
        $von = new Datum("");
        $von->addDays(-14);
        $von->setToMonatsErster();
        $bis = new Datum("");
        $bis->setToMonatsLetzter();
    }
    
    // Globale Varialben für Datums-Bereich setzen
    GlobalVars::setVar("vonDatum", $von);
    GlobalVars::setVar("bisDatum", $bis);
?>