<?php
    // Aktion für Import-Seite durchführen
    Input::setSource("post");

    // Hilfsfunktion: XML weiterlesen bis Element-Beginn:
    function nextElement(XMLReader $xr) {
        if(!$xr->read())
            return false;
        while($xr->nodeType != XMLReader::ELEMENT) {
            if(!$xr->read())
                return false;
        }
        //echo "nextElement: ".$xr->name."<br>";
        return true;
    }
    
    require("./control/importUpload.php");
    if (GlobalVars::getVar("upload_ok")) {
        $konto = Konto::findById(Input::getNumber("konto"));
        GlobalVars::setVar("konto", $konto);
        $iFile = fopen("./data/import.txt", "r");
        $xml = new XMLReader();
        $xml->XML(fread($iFile, 10000000));
        fclose($iFile);
        
        // Bei XML-Parsen zunächst Arrays mit importierten Daten anlegen:
        $bListe = array();
        $kListe = array();
        $fileOk = false;
        
        while (nextElement($xml)) {
            if ($xml->name == "Buchungen") {
                $b = array();
                while ($xml->name != "Kategorie") {
                    nextElement($xml);
                    $b[$xml->name] = $xml->readString();
                }
                array_push($bListe, $b);
            } else if ($xml->name == "Kategorien") {
                $k = array();
                while ($xml->name != "Bezeichnung") {
                    nextElement($xml);
                    $k[$xml->name] = $xml->readString();
                }
                array_push($kListe, $k);
            } else if ($xml->name == "HaushaltsKonto.xml")
                $fileOk = true;
        }

        if (!$fileOk)
            GlobalVars::push("messages", "Fehler: keine XML-Datei von Haushaltskonto.");
        else if (count($bListe) == 0)
            GlobalVars::push("messages", "Keine Buchungen vorhanden.");
        else {
            $jahr = substr($bListe[0]["Datum"],8);
            foreach ($kListe as $ix => $k) {
                $kSort = 10000 * $jahr + $k["ID"];
                $newKateg = Kategorie::neu();
                $newKateg->setSort($kSort);
                $newKateg->setBezeichnung($k["Bezeichnung"]);
                $newKateg->setAktiv(false);
                if (($kSort % 100) == 0) {
                    $newKateg->setArt("o");
                    $newKateg->setParent(null);
                }
                else {
                    $newKateg->setArt("u");
                    $parentSort = intdiv($kSort, 100) * 100;
                    $newKateg->setParent(Kategorie::findBySort($parentSort));
                }
                $newKateg->save();
            }
            foreach ($bListe as $ix => $b) {
                $kSort = 10000 * $jahr + $b["Kategorie"];
                $newBuchung = Buchung::neu();
                $newBuchung->setKonto($konto);
                $newBuchung->getDatum()->set($b["Datum"]);
                $betrag = str_replace(",", ".", $b["Betrag"]);
                $newBuchung->setBetrag($betrag);
                $newBuchung->setText($b["Text"]);
                $newBuchung->setStatus("a");
                $newBuchung->setKategorie(Kategorie::findBySort($kSort));
                $newBuchung->save();
            }
            GlobalVars::push("messages", count($bListe)." Buchungen importiert.");
            GlobalVars::push("messages", count($kListe)." Kategorien importiert.");
        }
    }
?>