<?php
class Buchung {
    private static $stati = array(   //*** mod.
        "i" => "importiert",
        "a" => "aktiv",
        "u" => "ursprung",
        "p" => "planung"
    );
    private static $buffer = array();
    private $persistent;
    private $id;
    private $konto;
    private $kontoId;
    private $datum;
    private $betrag;
    private $text;
    private $status;
    private $kategorie;
    private $kategorieId;
    private $ursprung;
    private $ursprungId;

    // **************** generierte statische Methoden ***************

    // Neues Objekt anlegen mit ID-Vergabe:
    static function neu() {
        $obj = new Buchung();
        $sql = new Sql("select max(id) from BC_buchung");
        $obj->id = $sql->selectSingleValue();
        if ($obj->id == "")
            $obj->id = 0;
        $obj->id++;
        return $obj;
    }

    // Suche mit ID, Liefere Objekt oder NULL:
    static function findById($id) {
        if (isset(self::$buffer[$id]))
            return self::$buffer[$id];
        $obj = NULL;
        $sql = new Sql("select id, konto, datum, betrag, text, status, kategorie, ursprung from BC_buchung");
        $sql->append(" where id = ".$id);
        $sql->execute();
        if ($row = $sql->fetch()) {
            $obj = new Buchung();
            $obj->setFromRow($row);
            self::$buffer[$obj->id] = $obj;
            $sql->free();
        }
        return $obj;
    }

    // Suche mit Where-Klausel und liefere Array von Objekten:
    private static function findByClause($clause) {
        $erg = array();
        $sql = new Sql("select id, konto, datum, betrag, text, status, kategorie, ursprung from BC_buchung ".$clause);
        $sql->execute();
        while ($row = $sql->fetch()) {
            if (isset(self::$buffer[$row->id]))
                array_push($erg, self::$buffer[$row->id]);
            else {
                $obj = new Buchung();
                $obj->setFromRow($row);
                array_push($erg, $obj);
                self::$buffer[$obj->id] = $obj;
            }
        }
        return $erg;
    }

    // **************** generierte Objekt-Methoden ***************

    function __construct () {
        $this->persistent = false;
        $this->id = 0;
        $this->konto = null;
        $this->kontoId = 0;
        $this->datum = new Datum("");
        $this->betrag = 0;
        $this->text = "";
        $this->status = "";
        $this->kategorie = null;
        $this->kategorieId = 0;
        $this->ursprung = null;
        $this->ursprungId = 0;
    }

    function equals($obj) {
        return (get_class() == get_class($obj) &&
                $this->id == $obj->getId());
    }

    // Attribute aus Query-Ergebniszeile setzen:
    private function setFromRow($row) {
        $this->persistent = true;
        $this->id = $row->id;
        $this->kontoId = $row->konto;
        $this->konto = null;
        $this->datum->set($row->datum);
        $this->betrag = $row->betrag;
        $this->text = $row->text;
        $this->status = $row->status;
        $this->kategorieId = $row->kategorie;
        $this->kategorie = null;
        $this->ursprungId = $row->ursprung;
        $this->ursprung = null;
    }

    // Speichern der Objekt-Attribute per Update oder Insert:
    function save() {
        if ($this->persistent) {
            $sql = new Sql("update BC_buchung");
            $sql->append(" set konto = ".$this->kontoId);
            $sql->append(" , datum = '".$this->datum->getDbFormat()."'");
            $sql->append(" , betrag = ".$this->betrag);
            $sql->append(" , text = '".$this->text."'");
            $sql->append(" , status = '".$this->status."'");
            $sql->append(" , kategorie = ".$this->kategorieId);
            $sql->append(" , ursprung = ".$this->ursprungId);
            $sql->append(" where id = ".$this->id);
        } else {
            $sql = new Sql("insert into BC_buchung");
            $sql->append(" ( id");
            $sql->append(" , konto");
            $sql->append(" , datum");
            $sql->append(" , betrag");
            $sql->append(" , text");
            $sql->append(" , status");
            $sql->append(" , kategorie");
            $sql->append(" , ursprung");
            $sql->append(" ) ");
            $sql->append("values");
            $sql->append(" ( ".$this->id);
            $sql->append(" , ".$this->kontoId);
            $sql->append(" , '".$this->datum->getDbFormat()."'");
            $sql->append(" , ".$this->betrag);
            $sql->append(" , '".$this->text."'");
            $sql->append(" , '".$this->status."'");
            $sql->append(" , ".$this->kategorieId);
            $sql->append(" , ".$this->ursprungId);
            $sql->append(" )");
        }
        $sql->execute();
        $this->persistent = true;
        self::$buffer[$this->id] = $this; // Buffer aktualisieren
    }

    // Objekt von Datenbank loeschen:
    function delete() {
        if (!$this->persistent)
            return false;
        $sql = new Sql("delete from BC_buchung");
        $sql->append(" where id = ".$this->id);
        $sql->execute();
        $this->persistent = false;
    }

    function getId() {
        return $this->id;
    }
    function getKonto() {
        if ($this->kontoId == 0)
            return null;
        if (is_null($this->konto))
            $this->konto = Konto::findById($this->kontoId);
        return $this->konto;
    }
    function setKonto($param) {
        $this->konto = $param;
        if (is_null($this->konto))
            $this->kontoId = 0;
        else
            $this->kontoId = $this->konto->getId();
    }
    function getDatum() {
        return $this->datum;
    }
    function setDatum($param) {
        $this->datum = $param;
    }
    function getBetrag() {
        return $this->betrag;
    }
    function setBetrag($param) {
        $this->betrag = $param;
    }
    function getText() {
        return $this->text;
    }
    function setText($param) {
        $this->text = $param;
    }
    function getStatus() {
        return $this->status;
    }
    function setStatus($param) {
        $this->status = $param;
    }
    function getKategorie() {
        if ($this->kategorieId == 0)
            return null;
        if (is_null($this->kategorie))
            $this->kategorie = Kategorie::findById($this->kategorieId);
        return $this->kategorie;
    }
    function setKategorie($param) {
        $this->kategorie = $param;
        if (is_null($this->kategorie))
            $this->kategorieId = 0;
        else
            $this->kategorieId = $this->kategorie->getId();
    }
    function getUrsprung() {     // *** mod. !!!
        if ($this->ursprungId == 0)
            return null;
        if (is_null($this->ursprung)) {
            if ($this->status == "p")
                $this->ursprung = PlanPosten::findById($this->ursprungId);
            else
                $this->ursprung = Buchung::findById($this->ursprungId);
        }
        return $this->ursprung;
    }
    function setUrsprung($param) {
        $this->ursprung = $param;
        if (is_null($this->ursprung))
            $this->ursprungId = 0;
        else
            $this->ursprungId = $this->ursprung->getId();
    }

    // **************** Ende generierte Methoden ***************

    static function findByParms($konto, $status, $von, $bis) {
        $clause = " where konto = ".$konto->getId();
        if ($status == "*")
            $clause = $clause;   // alle Stati -> nichts zu ergänzen
        else if (strlen($status) == 1)
            $clause .= " and status = '".$status."'";
        else                     // zulässiger dritter Fall: a oder i
            $clause .= " and status <> 'u'";
        $clause .= " and datum >= '".$von->getDbFormat()."'";
        $clause .= " and datum <= '".$bis->getDbFormat()."'";
        $clause .= " order by datum, ursprung, betrag desc";
        return self::findByClause($clause);
    }

    static function getLetztesDatum($konto) {
        $res = new Datum("");
        $sql = new Sql("select max(datum) from BC_buchung where konto = ".$konto->getId());
        $sql->append(" and status = 'a'");
        $res->set($sql->selectSingleValue());
        return $res;
    }

    static function kategWirdVerwendet($kateg) {
        $sql = new Sql("select count(*) from BC_buchung where kategorie = ".$kateg->getId());
        return ($sql->selectSingleValue() > 0);
    }

    static function deletePlanBuchungen($konto) {
        $sql = new Sql("delete from BC_buchung where status = 'p' and konto = ".$konto->getId());
        $sql->execute();
    }

    function getTeilbuchungen() {
        $clause = " where ursprung = ".$this->id;
        return self::findByClause($clause);
    }

} // Ende Klasse Buchung
?>
