<?php
class Kategorie {
    private static $arten = array(   //*** mod.
        "o" => "Oberkategorie",
        "u" => "Unterkategorie"
    );
    private static $modus = "aktiv";   //*** mod.
    private static $buffer = array();
    private $persistent;
    private $id;
    private $art;
    private $bezeichnung;
    private $sort;
    private $parent;
    private $parentId;
    private $aktiv;
    private $aktivNum;

    // **************** generierte statische Methoden ***************

    // Neues Objekt anlegen mit ID-Vergabe:
    static function neu() {
        $obj = new Kategorie();
        $sql = new Sql("select max(id) from BC_kategorie");
        $obj->id = $sql->selectSingleValue();
        if ($obj->id == "")
            $obj->id = 0;
        $obj->id++;
        return $obj;
    }

    // Suche mit ID, Liefere Objekt oder NULL:
    static function findById($id) {
        if (isset(self::$buffer[$id]))
            return self::$buffer[$id];
        $obj = NULL;
        $sql = new Sql("select id, art, bezeichnung, sort, parent, aktiv from BC_kategorie");
        $sql->append(" where id = ".$id);
        $sql->execute();
        if ($row = $sql->fetch()) {
            $obj = new Kategorie();
            $obj->setFromRow($row);
            self::$buffer[$obj->id] = $obj;
            $sql->free();
        }
        return $obj;
    }

    // Suche mit Where-Klausel und liefere Array von Objekten:
    private static function findByClause($clause) {
        $erg = array();
        $sql = new Sql("select id, art, bezeichnung, sort, parent, aktiv from BC_kategorie ".$clause);
        $sql->execute();
        while ($row = $sql->fetch()) {
            if (isset(self::$buffer[$row->id]))
                array_push($erg, self::$buffer[$row->id]);
            else {
                $obj = new Kategorie();
                $obj->setFromRow($row);
                array_push($erg, $obj);
                self::$buffer[$obj->id] = $obj;
            }
        }
        return $erg;
    }

    // **************** generierte Objekt-Methoden ***************

    function __construct () {
        $this->persistent = false;
        $this->id = 0;
        $this->art = "";
        $this->bezeichnung = "";
        $this->sort = 0;
        $this->parent = null;
        $this->parentId = 0;
        $this->aktiv = false;
        $this->aktivNum = 0;
    }

    function equals($obj) {
        return (get_class() == get_class($obj) &&
                $this->id == $obj->getId());
    }

    // Attribute aus Query-Ergebniszeile setzen:
    private function setFromRow($row) {
        $this->persistent = true;
        $this->id = $row->id;
        $this->art = $row->art;
        $this->bezeichnung = $row->bezeichnung;
        $this->sort = $row->sort;
        $this->parentId = $row->parent;
        $this->parent = null;
        $this->aktivNum = $row->aktiv;
        if ($this->aktivNum == 1)
            $this->aktiv = true;
        else $this->aktiv = false;
    }

    // Speichern der Objekt-Attribute per Update oder Insert:
    function save() {
        if ($this->persistent) {
            $sql = new Sql("update BC_kategorie");
            $sql->append(" set art = '".$this->art."'");
            $sql->append(" , bezeichnung = '".$this->bezeichnung."'");
            $sql->append(" , sort = ".$this->sort);
            $sql->append(" , parent = ".$this->parentId);
            $sql->append(" , aktiv = ".$this->aktivNum);
            $sql->append(" where id = ".$this->id);
        } else {
            $sql = new Sql("insert into BC_kategorie");
            $sql->append(" ( id");
            $sql->append(" , art");
            $sql->append(" , bezeichnung");
            $sql->append(" , sort");
            $sql->append(" , parent");
            $sql->append(" , aktiv");
            $sql->append(" ) ");
            $sql->append("values");
            $sql->append(" ( ".$this->id);
            $sql->append(" , '".$this->art."'");
            $sql->append(" , '".$this->bezeichnung."'");
            $sql->append(" , ".$this->sort);
            $sql->append(" , ".$this->parentId);
            $sql->append(" , ".$this->aktivNum);
            $sql->append(" )");
        }
        $sql->execute();
        $this->persistent = true;
        self::$buffer[$this->id] = $this; // Buffer aktualisieren
    }

    // Objekt von Datenbank loeschen:
    function delete() {
        if (!$this->persistent)
            return false;
        $sql = new Sql("delete from BC_kategorie");
        $sql->append(" where id = ".$this->id);
        $sql->execute();
        $this->persistent = false;
    }

    function getId() {
        return $this->id;
    }
    function getArt() {
        return $this->art;
    }
    function setArt($param) {
        $this->art = $param;
    }
    function getBezeichnung() {
        return $this->bezeichnung;
    }
    function setBezeichnung($param) {
        $this->bezeichnung = $param;
    }
    function getSort() {
        return $this->sort;
    }
    function setSort($param) {
        $this->sort = $param;
    }
    function getParent() {
        if ($this->parentId == 0)
            return null;
        if (is_null($this->parent))
            $this->parent = Kategorie::findById($this->parentId);
        return $this->parent;
    }
    function setParent($param) {
        $this->parent = $param;
        if (is_null($this->parent))
            $this->parentId = 0;
        else
            $this->parentId = $this->parent->getId();
    }
    function getAktiv() {
        return $this->aktiv;
    }
    function setAktiv($param) {
        $this->aktiv = $param;
        if ($this->aktiv)
            $this->aktivNum = 1;
        else $this->aktivNum = 0;
    }

    // **************** Ende generierte Methoden ***************

    static function getAll() {
        $clause = "";
        if (self::$modus == "aktiv")
            $clause = " where aktiv = 1";
        $clause .= " order by sort";
        return self::findByClause($clause);
    }

    static function getOberKategorien() {
        $clause = " where art = 'o'";
        if (self::$modus == "aktiv")
            $clause .= " and aktiv = 1";
        $clause .= " order by sort";
        return self::findByClause($clause);
    }

    static function findBySort($s) {
        if (!is_numeric($s))
            return null;
        $clause = " where sort = ".$s;
        $res = self::findByClause($clause);
        return reset($res);
    }

    static function setModusAlle() {
        self::$modus = "alle";
    }
    static function setModusAktive() {
        self::$modus = "aktiv";
    }
    
    function istOberKategorie() {
        return $this->art == "o";
    }

    function istUnterKategorie() {
        return $this->art == "u";
    }

    function getArtText() {
        return self::$arten[$this->art];
    }

    function getCmbText() {
        return $this->bezeichnung." (".$this->sort.")";
    }

    function getUnterKategorien() {
        $clause = " where parent = ".$this->id;
        if (self::$modus == "aktiv")
            $clause .= " and aktiv = 1";
        $clause .= " order by sort";
        return self::findByClause($clause);
    }

} // Ende Klasse Kategorie
?>