<?php
class Konto {
    private static $buffer = array();
    private $persistent;
    private $id;
    private $bezeichnung;

    // **************** generierte statische Methoden ***************

    // Neues Objekt anlegen mit ID-Vergabe:
    static function neu() {
        $obj = new Konto();
        $sql = new Sql("select max(id) from BC_konto");
        $obj->id = $sql->selectSingleValue();
        if ($obj->id == "")
            $obj->id = 0;
        $obj->id++;
        return $obj;
    }

    // Bei erstem Zugriff alle Objekte in Puffer einlesen:
    static function readAll() {
        if (count(self::$buffer) > 0)
            return;
        $sql = new Sql("select id, bezeichnung from BC_konto");
        $sql->append(" order by id");
        $sql->execute();
        while ($row = $sql->fetch()) {
            $obj = new Konto();
            $obj->setFromRow($row);
            self::$buffer[$obj->id] = $obj;
        }
    }

    // Array mit allen Objekten liefern:
    static function getAll() {
        self::readAll();
        $erg = array();
        foreach (self::$buffer as $id => $obj)
            $erg[$id] = $obj;
        return $erg;
    }

    // Suche mit ID, Liefere Objekt oder NULL:
    static function findById($id) {
        self::readAll();
        return self::$buffer[$id];
    }

    // **************** generierte Objekt-Methoden ***************

    function __construct () {
        $this->persistent = false;
        $this->id = 0;
        $this->bezeichnung = "";
    }

    function equals($obj) {
        return (get_class() == get_class($obj) &&
                $this->id == $obj->getId());
    }

    // Attribute aus Query-Ergebniszeile setzen:
    private function setFromRow($row) {
        $this->persistent = true;
        $this->id = $row->id;
        $this->bezeichnung = $row->bezeichnung;
    }

    // Speichern der Objekt-Attribute per Update oder Insert:
    function save() {
        if ($this->persistent) {
            $sql = new Sql("update BC_konto");
            $sql->append(" set bezeichnung = '".$this->bezeichnung."'");
            $sql->append(" where id = ".$this->id);
        } else {
            $sql = new Sql("insert into BC_konto");
            $sql->append(" ( id");
            $sql->append(" , bezeichnung");
            $sql->append(" ) ");
            $sql->append("values");
            $sql->append(" ( ".$this->id);
            $sql->append(" , '".$this->bezeichnung."'");
            $sql->append(" )");
        }
        $sql->execute();
        $this->persistent = true;
        if (count(self::$buffer) > 0)
            self::$buffer[$this->id] = $this; // Buffer aktualisieren
    }

    // Objekt von Datenbank loeschen:
    function delete() {
        if (!$this->persistent)
            return false;
        $sql = new Sql("delete from BC_konto");
        $sql->append(" where id = ".$this->id);
        $sql->execute();
        $this->persistent = false;
    }

    function getId() {
        return $this->id;
    }
    function getBezeichnung() {
        return $this->bezeichnung;
    }
    function setBezeichnung($param) {
        $this->bezeichnung = $param;
    }
    // Getter-Methode fuer HTML-Select-Feld
    // zur Verwendnung mit HTML-Util-Klasse.
    function getCmbText() {
        return $this->bezeichnung; // *** ggf. Attribut anpassen!
    }

    // **************** Ende generierte Methoden ***************

    // Beliebiges Konto als Default liefern
    static function getAny() {
        self::readAll();
        return reset(self::$buffer);
    }

} // Ende Klasse Konto
?>