<?php
class Monat {
    private $date;

    function __construct($parm) {
        $this->set($parm);
    }

    function set($parm) {
        if (is_object($parm) && get_class($parm) == "Datum") {
            $this->date = new DateTime($parm->getDbFormat());
            return;
        }
        if ($parm == 0) {
            $this->date = new DateTime();
            return;
        }
        $m = $parm % 100;
        $y = floor($parm / 100);
        $this->date = new DateTime($y."-".$m."-1");
    }

    function equals($obj){
        if (!is_object($obj))
            return false;
        if (get_class($obj) != "Monat")
            return false;
        return ($this->getAsNumber() == $obj->getAsNumber());
    }

    function getAsNumber() {
        return $this->date->format("Y") * 100 + $this->date->format("m");
    }

    function getDispFormat() {
        return $this->date->format("m/Y");
    }

    function getMonatsErster() {
        return new Datum($this->date->format("Y-m")."-01");
    }

    function getMonatsLetzter() {
        $dt = new Datum($this->date->format("Y-m-d"));
        $dt->setToMonatsLetzter();
        return $dt;
    }

    function setToVormonat() {
        //$tmp = $this->date->format("Y-m-d"); // *** Trace-Hilfe
        $this->date = new DateTime($this->date->format("Y-m")."-01");
        $this->date->modify("-1 day");
        //BC_trace("  Monat.setToVormonat(".$tmp.") --> ".$this->date->format("Y-m-d"));
    }

    function setToFolgemonat() {
        //$tmp = $this->date->format("Y-m-d"); // *** Trace-Hilfe
        $this->date = new DateTime($this->date->format("Y-m")."-01");
        $this->date->modify("+1 month");
        //BC_trace("  Monat.setToFolgemonat(".$tmp.") --> ".$this->date->format("Y-m-d"));
    }
}
?>