<?php
class PlanPosten {
    private static $turnusArten = array(   //*** mod.
        "e" => "einmalig",
        "t" => "Tage",
        "m" => "Monate"
    );
    private static $buffer = array();
    private $persistent;
    private $id;
    private $konto;
    private $kontoId;
    private $beginn;
    private $ende;
    private $betrag;
    private $text;
    private $kategorie;
    private $kategorieId;
    private $turnusArt;
    private $turnusCount;

    // **************** generierte statische Methoden ***************

    // Neues Objekt anlegen mit ID-Vergabe:
    static function neu() {
        $obj = new PlanPosten();
        $sql = new Sql("select max(id) from BC_planposten");
        $obj->id = $sql->selectSingleValue();
        if ($obj->id == "")
            $obj->id = 0;
        $obj->id++;
        return $obj;
    }

    // Suche mit ID, Liefere Objekt oder NULL:
    static function findById($id) {
        if (isset(self::$buffer[$id]))
            return self::$buffer[$id];
        $obj = NULL;
        $sql = new Sql("select id, konto, beginn, ende, betrag, text, kategorie, turnusArt, turnusCount from BC_planposten");
        $sql->append(" where id = ".$id);
        $sql->execute();
        if ($row = $sql->fetch()) {
            $obj = new PlanPosten();
            $obj->setFromRow($row);
            self::$buffer[$obj->id] = $obj;
            $sql->free();
        }
        return $obj;
    }

    // Suche mit Where-Klausel und liefere Array von Objekten:
    private static function findByClause($clause) {
        $erg = array();
        $sql = new Sql("select id, konto, beginn, ende, betrag, text, kategorie, turnusArt, turnusCount from BC_planposten ".$clause);
        $sql->execute();
        while ($row = $sql->fetch()) {
            if (isset(self::$buffer[$row->id]))
                array_push($erg, self::$buffer[$row->id]);
            else {
                $obj = new PlanPosten();
                $obj->setFromRow($row);
                array_push($erg, $obj);
                self::$buffer[$obj->id] = $obj;
            }
        }
        return $erg;
    }

    // **************** generierte Objekt-Methoden ***************

    function __construct () {
        $this->persistent = false;
        $this->id = 0;
        $this->konto = null;
        $this->kontoId = 0;
        $this->beginn = new Datum("");
        $this->ende = new Datum("2099-12-31");   // *** mod.
        $this->betrag = 0;
        $this->text = "";
        $this->kategorie = null;
        $this->kategorieId = 0;
        $this->turnusArt = "";
        $this->turnusCount = 0;
    }

    function equals($obj) {
        return (get_class() == get_class($obj) &&
                $this->id == $obj->getId());
    }

    // Attribute aus Query-Ergebniszeile setzen:
    private function setFromRow($row) {
        $this->persistent = true;
        $this->id = $row->id;
        $this->kontoId = $row->konto;
        $this->konto = null;
        $this->beginn->set($row->beginn);
        $this->ende->set($row->ende);
        $this->betrag = $row->betrag;
        $this->text = $row->text;
        $this->kategorieId = $row->kategorie;
        $this->kategorie = null;
        $this->turnusArt = $row->turnusArt;
        $this->turnusCount = $row->turnusCount;
    }

    // Speichern der Objekt-Attribute per Update oder Insert:
    function save() {
        if ($this->persistent) {
            $sql = new Sql("update BC_planposten");
            $sql->append(" set konto = ".$this->kontoId);
            $sql->append(" , beginn = '".$this->beginn->getDbFormat()."'");
            $sql->append(" , ende = '".$this->ende->getDbFormat()."'");
            $sql->append(" , betrag = ".$this->betrag);
            $sql->append(" , text = '".$this->text."'");
            $sql->append(" , kategorie = ".$this->kategorieId);
            $sql->append(" , turnusArt = '".$this->turnusArt."'");
            $sql->append(" , turnusCount = ".$this->turnusCount);
            $sql->append(" where id = ".$this->id);
        } else {
            $sql = new Sql("insert into BC_planposten");
            $sql->append(" ( id");
            $sql->append(" , konto");
            $sql->append(" , beginn");
            $sql->append(" , ende");
            $sql->append(" , betrag");
            $sql->append(" , text");
            $sql->append(" , kategorie");
            $sql->append(" , turnusArt");
            $sql->append(" , turnusCount");
            $sql->append(" ) ");
            $sql->append("values");
            $sql->append(" ( ".$this->id);
            $sql->append(" , ".$this->kontoId);
            $sql->append(" , '".$this->beginn->getDbFormat()."'");
            $sql->append(" , '".$this->ende->getDbFormat()."'");
            $sql->append(" , ".$this->betrag);
            $sql->append(" , '".$this->text."'");
            $sql->append(" , ".$this->kategorieId);
            $sql->append(" , '".$this->turnusArt."'");
            $sql->append(" , ".$this->turnusCount);
            $sql->append(" )");
        }
        $sql->execute();
        $this->persistent = true;
        self::$buffer[$this->id] = $this; // Buffer aktualisieren
    }

    // Objekt von Datenbank loeschen:
    function delete() {
        if (!$this->persistent)
            return false;
        $sql = new Sql("delete from BC_planposten");
        $sql->append(" where id = ".$this->id);
        $sql->execute();
        $this->persistent = false;
    }

    function getId() {
        return $this->id;
    }
    function getKonto() {
        if ($this->kontoId == 0)
            return null;
        if (is_null($this->konto))
            $this->konto = Konto::findById($this->kontoId);
        return $this->konto;
    }
    function setKonto($param) {
        $this->konto = $param;
        if (is_null($this->konto))
            $this->kontoId = 0;
        else
            $this->kontoId = $this->konto->getId();
    }
    function getBeginn() {
        return $this->beginn;
    }
    function setBeginn($param) {
        $this->beginn = $param;
    }
    function getEnde() {
        return $this->ende;
    }
    function setEnde($param) {
        $this->ende = $param;
    }
    function getBetrag() {
        return $this->betrag;
    }
    function setBetrag($param) {
        $this->betrag = $param;
    }
    function getText() {
        return $this->text;
    }
    function setText($param) {
        $this->text = $param;
    }
    function getKategorie() {
        if ($this->kategorieId == 0)
            return null;
        if (is_null($this->kategorie))
            $this->kategorie = Kategorie::findById($this->kategorieId);
        return $this->kategorie;
    }
    function setKategorie($param) {
        $this->kategorie = $param;
        if (is_null($this->kategorie))
            $this->kategorieId = 0;
        else
            $this->kategorieId = $this->kategorie->getId();
    }
    function getTurnusArt() {
        return $this->turnusArt;
    }
    function setTurnusArt($param) {
        $this->turnusArt = $param;
    }
    function getTurnusCount() {
        return $this->turnusCount;
    }
    function setTurnusCount($param) {
        $this->turnusCount = $param;
    }

    // **************** Ende generierte Methoden ***************

    static function getForKonto($k) {
        $clause = " where konto = ".$k->getId()." order by kategorie, text";
        return self::findByClause($clause);
    }

    static function getTurnusListe() {
        $res = array();
        foreach (self::$turnusArten as $ix => $txt)
            array_push($res, new WertObjekt($ix, $txt));
        return $res;
    }

    function getTurnusText() {
        if ($this->turnusArt == "e")
            return "einmalig";
        return "alle ".$this->turnusCount." ".self::$turnusArten[$this->turnusArt];
    }

} // Ende Klasse PlanPosten
?>
