<?php
class Regel {
    private static $buffer = array();
    private $persistent;
    private $id;
    private $sort;
    private $keyString;
    private $kategorie;
    private $kategorieId;

    // **************** generierte statische Methoden ***************

    // Neues Objekt anlegen mit ID-Vergabe:
    static function neu() {
        $obj = new Regel();
        $sql = new Sql("select max(id) from BC_regel");
        $obj->id = $sql->selectSingleValue();
        if ($obj->id == "")
            $obj->id = 0;
        $obj->id++;
        return $obj;
    }

    // Suche mit ID, Liefere Objekt oder NULL:
    static function findById($id) {
        if (isset(self::$buffer[$id]))
            return self::$buffer[$id];
        $obj = NULL;
        $sql = new Sql("select id, sort, keyString, kategorie from BC_regel");
        $sql->append(" where id = ".$id);
        $sql->execute();
        if ($row = $sql->fetch()) {
            $obj = new Regel();
            $obj->setFromRow($row);
            self::$buffer[$obj->id] = $obj;
            $sql->free();
        }
        return $obj;
    }

    // Suche mit Where-Klausel und liefere Array von Objekten:
    private static function findByClause($clause) {
        $erg = array();
        $sql = new Sql("select id, sort, keyString, kategorie from BC_regel ".$clause);
        $sql->execute();
        while ($row = $sql->fetch()) {
            if (isset(self::$buffer[$row->id]))
                array_push($erg, self::$buffer[$row->id]);
            else {
                $obj = new Regel();
                $obj->setFromRow($row);
                array_push($erg, $obj);
                self::$buffer[$obj->id] = $obj;
            }
        }
        return $erg;
    }

    // **************** generierte Objekt-Methoden ***************

    function __construct () {
        $this->persistent = false;
        $this->id = 0;
        $this->sort = 0;
        $this->keyString = "";
        $this->kategorie = null;
        $this->kategorieId = 0;
    }

    function equals($obj) {
        return (get_class() == get_class($obj) &&
                $this->id == $obj->getId());
    }

    // Attribute aus Query-Ergebniszeile setzen:
    private function setFromRow($row) {
        $this->persistent = true;
        $this->id = $row->id;
        $this->sort = $row->sort;
        $this->keyString = $row->keyString;
        $this->kategorieId = $row->kategorie;
        $this->kategorie = null;
    }

    // Speichern der Objekt-Attribute per Update oder Insert:
    function save() {
        if ($this->persistent) {
            $sql = new Sql("update BC_regel");
            $sql->append(" set sort = ".$this->sort);
            $sql->append(" , keyString = '".$this->keyString."'");
            $sql->append(" , kategorie = ".$this->kategorieId);
            $sql->append(" where id = ".$this->id);
        } else {
            $sql = new Sql("insert into BC_regel");
            $sql->append(" ( id");
            $sql->append(" , sort");
            $sql->append(" , keyString");
            $sql->append(" , kategorie");
            $sql->append(" ) ");
            $sql->append("values");
            $sql->append(" ( ".$this->id);
            $sql->append(" , ".$this->sort);
            $sql->append(" , '".$this->keyString."'");
            $sql->append(" , ".$this->kategorieId);
            $sql->append(" )");
        }
        $sql->execute();
        $this->persistent = true;
        self::$buffer[$this->id] = $this; // Buffer aktualisieren
    }

    // Objekt von Datenbank loeschen:
    function delete() {
        if (!$this->persistent)
            return false;
        $sql = new Sql("delete from BC_regel");
        $sql->append(" where id = ".$this->id);
        $sql->execute();
        $this->persistent = false;
    }

    function getId() {
        return $this->id;
    }
    function getSort() {
        return $this->sort;
    }
    function setSort($param) {
        $this->sort = $param;
    }
    function getKeyString() {
        return $this->keyString;
    }
    function setKeyString($param) {
        $this->keyString = $param;
    }
    function getKategorie() {
        if ($this->kategorieId == 0)
            return null;
        if (is_null($this->kategorie))
            $this->kategorie = Kategorie::findById($this->kategorieId);
        return $this->kategorie;
    }
    function setKategorie($param) {
        $this->kategorie = $param;
        if (is_null($this->kategorie))
            $this->kategorieId = 0;
        else
            $this->kategorieId = $this->kategorie->getId();
    }

    // **************** Ende generierte Methoden ***************

    static function getAll() {
        $clause = " order by sort";
        return self::findByClause($clause);
    }
    
    static function kategWirdVerwendet($kateg) {
        $sql = new Sql("select count(*) from BC_regel where kategorie = ".$kateg->getId());
        return ($sql->selectSingleValue() > 0);
    }

    static function getKategFromText($text) {
        if (count(self::$buffer) == 0)
            self::getAll();
        $tu = strtoupper($text);
        foreach (self::$buffer as $ix => $r) {
            if (!(strpos($tu, strtoupper($r->keyString)) === false))
                return $r->getKategorie();
        }
        return null;
    }

} // Ende Klasse Regel
?>