<?php
class TextRegel {
    private static $buffer = array();
    private $persistent;
    private $id;
    private $sort;
    private $keyString;
    private $toString;

    // **************** generierte statische Methoden ***************

    // Neues Objekt anlegen mit ID-Vergabe:
    static function neu() {
        $obj = new TextRegel();
        $sql = new Sql("select max(id) from BC_textregel");
        $obj->id = $sql->selectSingleValue();
        if ($obj->id == "")
            $obj->id = 0;
        $obj->id++;
        return $obj;
    }

    // Suche mit ID, Liefere Objekt oder NULL:
    static function findById($id) {
        if (isset(self::$buffer[$id]))
            return self::$buffer[$id];
        $obj = NULL;
        $sql = new Sql("select id, sort, keyString, toString from BC_textregel");
        $sql->append(" where id = ".$id);
        $sql->execute();
        if ($row = $sql->fetch()) {
            $obj = new TextRegel();
            $obj->setFromRow($row);
            self::$buffer[$obj->id] = $obj;
            $sql->free();
        }
        return $obj;
    }

    // Suche mit Where-Klausel und liefere Array von Objekten:
    private static function findByClause($clause) {
        $erg = array();
        $sql = new Sql("select id, sort, keyString, toString from BC_textregel ".$clause);
        $sql->execute();
        while ($row = $sql->fetch()) {
            if (isset(self::$buffer[$row->id]))
                array_push($erg, self::$buffer[$row->id]);
            else {
                $obj = new TextRegel();
                $obj->setFromRow($row);
                array_push($erg, $obj);
                self::$buffer[$obj->id] = $obj;
            }
        }
        return $erg;
    }

    // **************** generierte Objekt-Methoden ***************

    function __construct () {
        $this->persistent = false;
        $this->id = 0;
        $this->sort = 0;
        $this->keyString = "";
        $this->toString = "";
    }

    function equals($obj) {
        return (get_class() == get_class($obj) &&
                $this->id == $obj->getId());
    }

    // Attribute aus Query-Ergebniszeile setzen:
    private function setFromRow($row) {
        $this->persistent = true;
        $this->id = $row->id;
        $this->sort = $row->sort;
        $this->keyString = $row->keyString;
        $this->toString = $row->toString;
    }

    // Speichern der Objekt-Attribute per Update oder Insert:
    function save() {
        if ($this->persistent) {
            $sql = new Sql("update BC_textregel");
            $sql->append(" set sort = ".$this->sort);
            $sql->append(" , keyString = '".$this->keyString."'");
            $sql->append(" , toString = '".$this->toString."'");
            $sql->append(" where id = ".$this->id);
        } else {
            $sql = new Sql("insert into BC_textregel");
            $sql->append(" ( id");
            $sql->append(" , sort");
            $sql->append(" , keyString");
            $sql->append(" , toString");
            $sql->append(" ) ");
            $sql->append("values");
            $sql->append(" ( ".$this->id);
            $sql->append(" , ".$this->sort);
            $sql->append(" , '".$this->keyString."'");
            $sql->append(" , '".$this->toString."'");
            $sql->append(" )");
        }
        $sql->execute();
        $this->persistent = true;
        if (count(self::$buffer) > 0)            self::$buffer[$this->id] = $this; // Buffer aktualisieren
    }

    // Objekt von Datenbank loeschen:
    function delete() {
        if (!$this->persistent)
            return false;
        $sql = new Sql("delete from BC_textregel");
        $sql->append(" where id = ".$this->id);
        $sql->execute();
        $this->persistent = false;
        self::$buffer[$this->id] = null; // Buffer aktualisieren
    }

    function getId() {
        return $this->id;
    }
    function getSort() {
        return $this->sort;
    }
    function setSort($param) {
        $this->sort = $param;
    }
    function getKeyString() {
        return $this->keyString;
    }
    function setKeyString($param) {
        $this->keyString = $param;
    }
    function getToString() {
        return $this->toString;
    }
    function setToString($param) {
        $this->toString = $param;
    }

    // **************** Ende generierte Methoden ***************

    static function getAll() {
        $clause = " order by sort";
        return self::findByClause($clause);
    }
    
    static function applyToBuchung($bu) {
        if (count(self::$buffer) == 0)
            self::getAll();
        $text = $bu->getText();
        foreach (self::$buffer as $ix => $tr) {
            if (!(strpos($text, $tr->getKeyString()) === false)) {
                $bu->setText($tr->getToString());
                return true;
            }
        }
        return false;
    }

} // Ende Klasse TextRegel
?>