/**
 * Skript für Basis-Funktionen für Gis Gemeinde-Planer
 */

var bc = window.bc || {};

// Ausgabe Popup-Meldung
bc.showMessage = function(msg) {
    if (msg === "")
        return;
    _msg = msg.replace(/--/g, "<br>");
    $("<div>")
        .hide()
        .html(_msg)
        .addClass("message")
        .appendTo("main")
        .fadeIn(500)
        .delay(2000)
        .slideUp(1000, function() { $(this).remove(); })
    ;
};

// Standard-Behandlung von Request-Fehlern: Dump-Div füllen
bc.requestFail = function(xhr){
    $("#dump").html(xhr.responseText);
};

// Callback-Funktion für Monats- und Jahres-Änderung im Date-Picker:
// Neu entstandenes Datum sofort übernehmen!
bc.datumMJChange = function(year, month, dtInst) {
    var _maxDays = [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31],
        _id = "#" + dtInst.id,
        _day = dtInst.currentDay,
    endvar;
    
    if (_day > _maxDays[month])
        _day = _maxDays[month];
    $(_id).datepicker( "setDate", _day + "." + month + "." + year );
};

// Datums-Eingabefelder initialisieren:
bc.initDatumInput = function() {
    var _datumMJChange = bc.datumMJChange;
    
    // $.datepicker.setDefaults($.datepicker.regional["de"]);
    $("input.datum").datepicker({
        firstDay: 1,
        dateFormat: "dd.mm.yy",
        dayNamesMin: [ "So", "Mo", "Di", "Mi", "Do", "Fr", "Sa" ],
        monthNamesShort: [ "Jan", "Feb", "Mar", "Apr", "Mai", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dez" ],
        minDate: new Date(1900, 1, 1),
        changeMonth: true,
        changeYear:true,
        yearRange: "1900:2099",
        onChangeMonthYear : _datumMJChange
    });
};


$(document).ready(function() {
    // Handling Logout-Link
    $("#logout").on("click", function(event) {
        event.stopPropagation();
        window.location = "index.php?action=logout";
    });
});
