$(document).ready(function() {
    "use strict";
    var _saveUrl = "service/kategSave.php",
        _reloadUrl = "main.php?open=admin&select=kategorien",
        _showMessage = bc.showMessage,
        _requestFail = bc.requestFail,
        _tdAction = undefined,
        _tdBezeichnung = undefined,
        _tdSort = undefined,
        _tdAktiv = undefined,
        _tmpArt = undefined,
        _filterChange = function(){},
        _actionClick = function(){},
        _artChange = function(){},
        _newClick = function(){},
        _saveClick = function(){},
    _endvar;

    // Checkbox für Filter "nur aktive" geändert -> refresh
    _filterChange = function(event) {
        var _url = _reloadUrl;
        if (!$("#chkAktive").prop("checked"))
            _url += "&inaktive=ja";
        window.location = _url;
    };
    
    // Klick auf Action-Icon bei vorhandener Kategorie
    _actionClick = function(event) {
        var _url = _saveUrl,
            _bez = undefined,
            _chkAktiv = "",
            _request = undefined,
        _endvar;
        _tdAction = $(event.target).parent("td");
        if ($(event.target).data("art") == "delete") {
            _url += "?action=delete&ID=" + _tdAction.data("id");
            _request = $.ajax({url: _url, dataType: "json"});
            _request
                .done(function(data){
                    _showMessage(data.message);
                    if (data.success == "yes")
                        window.location = _reloadUrl;
                })
                .fail(_requestFail);
        } else { // art = edit -> Zeile editierbar machen
            _tdAktiv = _tdAction.prev("td");
            _tdSort = _tdAktiv.prev("td");
            _tdBezeichnung = _tdSort.prev("td");
            _tmpArt = _tdBezeichnung.prev("td").html();
            if (_tmpArt.startsWith("Unter"))
                _bez = _tdBezeichnung.html().substring(18);
            else
                _bez = _tdBezeichnung.html();
            _tdBezeichnung.html('<input id="editBez" value="' + _bez + '">');
            _tdSort.html('<input id="editSort" value="' + _tdSort.html() + '">');
            if (_tdAktiv.html() == "ja")
                _chkAktiv = " checked";
            _tdAktiv.html('<input id="editAktiv" type="checkbox"' + _chkAktiv + '> aktiv');
            _tdAction.html('<button type="button" id="btnSave">speichern</button>');
            $("#btnSave").on("click", _saveClick);
        }
    }

    // Klick auf "speichern" bei Kategorie-Bearbeitung
    _saveClick = function(event) {
        var _url = _saveUrl,
            _request = undefined,
        _endvar;
        _url += "?action=save&ID=" + _tdAction.data("id") + 
                "&bez=" + $("#editBez").val() + 
                "&sort=" + $("#editSort").val();
        if ($("#editAktiv").prop("checked"))
            _url += "&aktiv=on";
        _request = $.ajax({url: _url, dataType: "json"});
        _request
            .done(function(data){
                var _bez = undefined;
                _showMessage(data.message);
                if (data.success == "yes") {
                    if (_tmpArt.startsWith("Unter"))
                        _bez = "&gt;&gt;&gt;&nbsp;" + $("#editBez").val();
                    else
                        _bez = $("#editBez").val();
                    _tdBezeichnung.html(_bez);
                    _tdSort.html($("#editSort").val());
                    if ($("#editAktiv").prop("checked"))
                        _tdAktiv.html("ja");
                    else
                        _tdAktiv.html("nein");
                    _tdAction.html("&nbsp;");
                }
            })
            .fail(_requestFail);
    }

    // Ändern der Art (Ober-/Unter-Kateg) in Anlege-Zeile
    _artChange = function(event) {
        if ($(event.target).val() == "o")
            $("#divParent").hide();
        else
            $("#divParent").show();
    }

    // Klick auf Neu-Button in Anlege-Zeile
    _newClick = function(event) {
        var _url = _saveUrl,
            _request = undefined,
        _endvar;

        if ($("#newKategBez").val() == "") {
            _showMessage("Bitte Bezeichnung eingeben.");
            return;
        }
        if ($("#newKategSort").val() == 0) {
            _showMessage("Bitte Sort-Nummer größer Null eingeben.");
            return;
        }
        _url += "?ID=neu&action=save&art=" + $("#newKategArt").val() +
                "&parent=" + $("#newKategParent").val() +
                "&bez=" + $("#newKategBez").val() +
                "&sort=" + $("#newKategSort").val();
        if ($("#newKategAktiv").prop("checked"))
            _url += "&aktiv=on";
        _request = $.ajax({url: _url, dataType: "json"});
        _request
            .done(function(data){
                _showMessage(data.message);
                if (data.success == "yes")
                    _filterChange(null);
            })
            .fail(_requestFail);
    };

    // Datums-Felder initialisieren
    $("#divParent").hide();
    $("#chkAktive").on("click", _filterChange);
    $("td img").on("click", _actionClick);
    $("#btnNew").on("click", _newClick);
    $("#newKategArt").on("change", _artChange);
});