$(document).ready(function() {
    "use strict";
    var _saveUrl = "service/regelSave.php",
        _getKategSelectUrl = "./service/getKategSelect.php",
        _reloadUrl = "main.php?open=admin&select=regeln",
        _showMessage = bc.showMessage,
        _requestFail = bc.requestFail,
        _tdAction = undefined,
        _tdKeyString = undefined,
        _tdKateg = undefined,
        _tdSort = undefined,
        _kategTarget = "new",
        _editKategId = undefined,
        _actionClick = function(){},
        _loadEditKategs = function(){},
        _oberKategChange = function(){},
        _newClick = function(){},
        _saveClick = function(){},
    _endvar;

    // Klick auf Action-Icon bei vorhandener Regel
    _actionClick = function(event) {
        var _url = _saveUrl,
            _request = undefined,
        _endvar;
        _tdAction = $(event.target).parent("td");
        if ($(event.target).data("art") == "delete") {
            _url += "?action=delete&ID=" + _tdAction.data("id");
            _request = $.ajax({url: _url, dataType: "json"});
            _request
                .done(function(data){
                    _showMessage(data.message);
                    if (data.success == "yes")
                        window.location = _reloadUrl;
                })
                .fail(_requestFail);
        } else { // art = edit -> Zeile editierbar machen
            _tdSort = _tdAction.prev("td");
            _tdKateg = _tdSort.prev("td");
            _tdKeyString = _tdKateg.prev("td");
            _tdKeyString.html('<input id="editKey" value="' + _tdKeyString.html() + '">');
            _tdSort.html('<input id="editSort" value="' + _tdSort.html() + '">');
            _tdAction.html('<button type="button" id="btnSave">speichern</button>');
            _loadEditKategs(_tdKateg);
            $("#btnSave").on("click", _saveClick);
            $("#trNew").hide();
        }
    }

    // Komplettieren Regel-Editier-Zeile mit Kategorie-Combos
    _loadEditKategs = function(tdKateg) {
        var _url = _getKategSelectUrl,
            _oberKategId = undefined,
            _request = undefined,
        _endvar;
        
        _oberKategId = tdKateg.data("oberid");
        _editKategId = tdKateg.data("unterid");
        // Ober-Kategorie-Combo laden
        _url += "?selectid=editOberKateg&ID=0";
        _request = $.ajax({url: _url, dataType: "html"});
        _request
            .done(function(data){
                $(tdKateg).html(data + '<div id="divEditKateg"></div>');
                $("#editOberKateg").val(_oberKategId);
                $("#editOberKateg").on("change", _oberKategChange);
                _kategTarget = "edit";
                _oberKategChange();
            })
            .fail(_requestFail);
    }

    // bei Ändern der Oberkategorie für Regel: Unterkategorie nachladen
    _oberKategChange = function(event) {
        var _url = _getKategSelectUrl,
            _destinDiv = undefined,
            _request = undefined,
        _endvar;

        if (_kategTarget == "new") {
            // Keine Edit-Aktion offen --> Change in Neuanlage-Zeile
            _url += "?selectid=newUnterKateg&ID=" + $("#newOberKateg").val();
            _destinDiv = "#divUnterKateg";
        } else {  // kategTarget = edit
            _url += "?selectid=editUnterKateg&ID=" + $("#editOberKateg").val();
            _destinDiv = "#divEditKateg";
        }
        _request = $.ajax({url: _url, dataType: "html"});
        _request
            .done(function(data){
                $(_destinDiv).html(data);
                if (_destinDiv == "#divEditKateg" && _editKategId > 0) {
                    $("#editUnterKateg").val(_editKategId);
                    _editKategId = 0;
                }
            })
            .fail(_requestFail);
    }


    // Klick auf "speichern" bei Kategorie-Bearbeitung
    _saveClick = function(event) {
        var _url = _saveUrl,
            _request = undefined,
        _endvar;
        _url += "?action=save&ID=" + _tdAction.data("id") + 
                "&keyString=" + $("#editKey").val() + 
                "&kategorie=" + $("#editUnterKateg").val() +
                "&sort=" + $("#editSort").val();
        _request = $.ajax({url: _url, dataType: "json"});
        _request
            .done(function(data){
                _showMessage(data.message);
                if (data.success == "yes") {
                    _tdKeyString.html($("#editKey").val());
                    _tdKateg.html(data.kategBez);
                    _tdSort.html($("#editSort").val());
                    _tdAction.html("&nbsp;");
                    _kategTarget = "new";
                    $("#trNew").show();
                }
            })
            .fail(_requestFail);
    }

    // Klick auf Neu-Button in Anlege-Zeile
    _newClick = function(event) {
        var _url = _saveUrl,
            _request = undefined,
        _endvar;

        if ($("#newRegelKeyString").val() == "") {
            _showMessage("Bitte Schlüssel-Text eingeben.");
            return;
        }
        if ($("#newRegelSort").val() == 0) {
            _showMessage("Bitte Sort-Nummer größer Null eingeben.");
            return;
        }
        _url += "?ID=neu&action=save&keyString=" + $("#newRegelKeyString").val() +
                "&kategorie=" + $("#newUnterKateg").val() +
                "&sort=" + $("#newRegelSort").val();
        _request = $.ajax({url: _url, dataType: "json"});
        _request
            .done(function(data){
                _showMessage(data.message);
                if (data.success == "yes")
                    window.location = _reloadUrl;
            })
            .fail(_requestFail);
    }

    // Seitenelemente initialisieren
    $("td img").on("click", _actionClick);
    $("#newOberKateg").on("change", _oberKategChange);
    $("#btnNew").on("click", _newClick);
    _oberKategChange();
});