$(document).ready(function() {
    "use strict";
    var _saveUrl = "service/textRegelSave.php",
        _reloadUrl = "main.php?open=admin&select=textregeln",
        _showMessage = bc.showMessage,
        _requestFail = bc.requestFail,
        _tdAction = undefined,
        _tdKeyString = undefined,
        _tdReplString = undefined,
        _tdSort = undefined,
        _actionClick = function(){},
        _newClick = function(){},
        _saveClick = function(){},
    _endvar;

    // Klick auf Action-Icon bei vorhandener Regel
    _actionClick = function(event) {
        var _url = _saveUrl,
            _request = undefined,
        _endvar;
        _tdAction = $(event.target).parent("td");
        if ($(event.target).data("art") == "delete") {
            _url += "?action=delete&ID=" + _tdAction.data("id");
            _request = $.ajax({url: _url, dataType: "json"});
            _request
                .done(function(data){
                    _showMessage(data.message);
                    if (data.success == "yes")
                        window.location = _reloadUrl;
                })
                .fail(_requestFail);
        } else { // art = edit -> Zeile editierbar machen
            _tdSort = _tdAction.prev("td");
            _tdReplString = _tdSort.prev("td");
            _tdKeyString = _tdReplString.prev("td");
            _tdKeyString.html('<input id="editKey" value="' + _tdKeyString.html() + '">');
            _tdReplString.html('<input id="editRepl" value="' + _tdReplString.html() + '">');
            _tdSort.html('<input id="editSort" value="' + _tdSort.html() + '">');
            _tdAction.html('<button type="button" id="btnSave">speichern</button>');
            $("#btnSave").on("click", _saveClick);
            $("#trNew").hide();
        }
    }

    // Klick auf "speichern" bei Textregel-Bearbeitung
    _saveClick = function(event) {
        var _url = _saveUrl,
            _request = undefined,
        _endvar;
        _url += "?action=save&ID=" + _tdAction.data("id") + 
                "&keyString=" + $("#editKey").val() + 
                "&replString=" + $("#editRepl").val() +
                "&sort=" + $("#editSort").val();
        _request = $.ajax({url: _url, dataType: "json"});
        _request
            .done(function(data){
                _showMessage(data.message);
                if (data.success == "yes") {
                    _tdKeyString.html($("#editKey").val());
                    _tdReplString.html($("#editRepl").val());
                    _tdSort.html($("#editSort").val());
                    _tdAction.html("&nbsp;");
                    $("#trNew").show();
                }
            })
            .fail(_requestFail);
    }

    // Klick auf Neu-Button in Anlege-Zeile
    _newClick = function(event) {
        var _url = _saveUrl,
            _request = undefined,
        _endvar;

        if ($("#newRegelKeyString").val() == "") {
            _showMessage("Bitte Schlüssel-Text eingeben.");
            return;
        }
        if ($("#newRegelReplString").val() == "") {
            _showMessage("Bitte Ersetzungs-Text eingeben.");
            return;
        }
        if ($("#newRegelSort").val() == 0) {
            _showMessage("Bitte Sort-Nummer größer Null eingeben.");
            return;
        }
        _url += "?ID=neu&action=save&keyString=" + $("#newRegelKeyString").val() +
                "&replString=" + $("#newRegelReplString").val() +
                "&sort=" + $("#newRegelSort").val();
        _request = $.ajax({url: _url, dataType: "json"});
        _request
            .done(function(data){
                _showMessage(data.message);
                if (data.success == "yes")
                    window.location = _reloadUrl;
            })
            .fail(_requestFail);
    }

    // Seitenelemente initialisieren
    $("td img").on("click", _actionClick);
    $("#btnNew").on("click", _newClick);
});