$(document).ready(function() {
    "use strict";
    var _saveUrl = "service/importSave.php",
        _loadRegelnUrl = "service/loadRegeln.php",
        _showMessage = bc.showMessage,
        _requestFail = bc.requestFail,
        _regeln = [],
        _actionClick = function(){},
        _acceptRow = function(){},
        _loadRegeln = function(){},
        _textChange = function(){},
    _endvar;

    // Klick auf Action-Icon bei importierter Buchung
    _actionClick = function(event) {
        var _url = _saveUrl,
            _action = $(event.target).data("action"),
            _tdAction = $(event.target).parent(),
            _trAction = undefined,
            _text = undefined,
            _request = undefined,
        _endvar;
        _trAction = _tdAction.parent("tr");
        if (_action == "accept")
            _acceptRow(_trAction);
        else if (_action == "acceptAll") {
            _trAction = _trAction.next("tr").next("tr");
            while (_trAction.hasClass("buchung")) {
                _acceptRow(_trAction);
                _trAction = _trAction.next("tr");
            }
        } else if (_action == "delete") {
            _url += "?action=delete&ID=" + _tdAction.data("buchungid");
            _request = $.ajax({url: _url, dataType: "json"});
            _request
                .done(function(data){
                    _showMessage(data.message);
                    if (data.success == "yes")
                        _trAction.hide();
                })
                .fail(_requestFail);
        }
    };

    _acceptRow = function(row) {
        var _url = _saveUrl,
            _tdText = undefined,
            _tdKateg = undefined,
            _request = undefined,
        _endvar;
        _tdText = row.children("td").first().next();
        _tdKateg = _tdText.next().next();

        _url += "?action=accept&ID=" + _tdKateg.next().data("buchungid") +
                "&text=" + _tdText.children("input").val() +
                "&kategorie=" + _tdKateg.data("kategid");
        _request = $.ajax({url: _url, dataType: "json"});
        _request
            .done(function(data){
                _showMessage(data.message);
                if (data.success == "yes")
                    row.hide();
            })
            .fail(_requestFail);
    };

    // Kategorie-Regeln für Textvorschläge und On-the-fly-Anwendung laden:
    _loadRegeln = function() {
        var _request = undefined,
            _texte = [],
            _options = "",
            i = undefined,
        _endvar;

        _request = $.ajax({ url: _loadRegelnUrl, dataType: "json" });
        _request
            .done(function (data) {
                if (data.success != "yes") {
                    _showMessage(data.message);
                    return;
                }
                _regeln = data.regeln;
                for (i = 0; i < _regeln.length; i++)
                    _texte[i] = data.regeln[i].keyString;
                _texte.sort();
                for (i = 0; i < _texte.length; i++)
                    _options += "<option value=\"" + _texte[i] + "\"></option>";
                $("#texte").html(_options);
            })
            .fail(_requestFail);
    };
    
    // Bei Text-Änderung sofort Kategorie-Regeln anwenden:
    _textChange = function(event) {
        var i = undefined,
            _myText = $(event.target).val(),
            _tdKateg = $(event.target).parent("td").next().next(),
        endvar;
        
        for (i = 0; i < _regeln.length; i++) {
            if (_myText.includes(_regeln[i].keyString)) {
                _tdKateg.html(_regeln[i].kategText);
                _tdKateg.data("kategid", _regeln[i].kategKey);
                return;
            }
        }
        _tdKateg.html("-null-");
        _tdKateg.data("kategid", "0");
    };

    // Seitenelemente initialisieren
    $("img.action").on("click", _actionClick);
    $("input.text").on("keyup", _textChange);

    // Kategorie-Regeln holen
    _loadRegeln();
});