-- Installation BControl - Anlegen Tabellen und Initial-Daten

-- --------------------------------------------------------
--
-- Tabellenstruktur für Tabelle BC_buchung
--

CREATE TABLE BC_buchung (
  id int(10) UNSIGNED NOT NULL,
  konto int(10) NOT NULL,
  datum date NOT NULL,
  betrag decimal(8,2) NOT NULL,
  text varchar(512) NOT NULL,
  status char(1) NOT NULL,
  kategorie int(10) NOT NULL DEFAULT '0',
  ursprung int(10) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------
--
-- Tabellenstruktur für Tabelle BC_kategorie
--

CREATE TABLE BC_kategorie (
  id int(10) UNSIGNED NOT NULL,
  art char(1) NOT NULL,
  bezeichnung varchar(80) NOT NULL,
  sort int(11) NOT NULL,
  parent int(10) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------
--
-- Tabellenstruktur für Tabelle BC_konto
--

CREATE TABLE BC_konto (
  id int(10) UNSIGNED NOT NULL,
  bezeichnung varchar(80) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------
--
-- Tabellenstruktur für Tabelle BC_me_saldo
--

CREATE TABLE BC_me_saldo (
  id int(10) UNSIGNED NOT NULL,
  konto int(10) NOT NULL,
  monat int(6) NOT NULL,
  saldo decimal(9,2) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------
--
-- Tabellenstruktur für Tabelle BC_planposten
--

CREATE TABLE BC_planposten (
  id int(10) UNSIGNED NOT NULL,
  konto int(10) NOT NULL,
  beginn date NOT NULL,
  ende date NOT NULL,
  betrag decimal(8,2) NOT NULL,
  text varchar(128) NOT NULL,
  kategorie int(10) NOT NULL,
  turnusArt char(1) NOT NULL,
  turnusCount int(4) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------
--
-- Tabellenstruktur für Tabelle BC_regel
--

CREATE TABLE BC_regel (
  id int(10) UNSIGNED NOT NULL,
  sort int(10) NOT NULL,
  keyString varchar(80) NOT NULL,
  kategorie int(10) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------
--
-- Indizes der exportierten Tabellen
--
ALTER TABLE BC_buchung
  ADD PRIMARY KEY (id);
ALTER TABLE BC_kategorie
  ADD PRIMARY KEY (id);
ALTER TABLE BC_konto
  ADD PRIMARY KEY (id);
ALTER TABLE BC_me_saldo
  ADD PRIMARY KEY (id);
ALTER TABLE BC_planposten
  ADD PRIMARY KEY (id);
ALTER TABLE BC_regel
  ADD PRIMARY KEY (id);

-- --------------------------------------------------------
--
-- Daten für erstes, initiales Konto und Dummy-Kategorien
--
INSERT INTO BC_konto
  (id, bezeichnung) 
  VALUES (1, 'Konto1');

INSERT INTO BC_kategorie (id, art, bezeichnung, sort, parent) VALUES
(1, 'o', 'Erste Gruppe', 100, 0),
(2, 'u', 'Erste Kategorie', 110, 1);

-- --------------------------------------------------------
COMMIT;
