$(document).ready(function() {
    "use strict";
    var _reloadUrl = "main.php?open=konto",
        _splitUrl = "main.php?open=konto&select=split",
        _getKategSelectUrl = "./service/getKategSelect.php",
        _loadRegelnUrl = "service/loadRegeln.php",
        _editFormUrl = "./service/getBuchungEditForm.php",
        _buchungSaveUrl = "./service/buchungSave.php",
        _showMessage = bc.showMessage,
        _requestFail = bc.requestFail,
        _filterText = undefined,
        _tdAction = undefined,
        _doFilter = function(){},
        _refreshClick = function(){},
        _refresh = function(){},
        _expandClick = function(){},
        _collapseClick = function(){},
        _regeln = undefined,
        _regelKategId = 0,
        _loadRegeln = function(){},
        _textChange = function(){},
        _newOberKategChange = function(){},
        _actionClick = function(){},
        _deleteSure = function(){},
        _saveClick = function(){},
        _newClick = function(){},
    _endvar;

    // jQuery-Extension zur Filterung nach Buchungstext und Kategorie
    $.fn.filterBuchung = function() {
        this.each(function() {
            if ($(this).data("filter").toUpperCase().includes(_filterText))
                $(this).show();
            else
                $(this).hide();
        });
        return this;
    }

    // Buchungs-Filterung aktualisieren
    _doFilter = function(event) {
        _filterText = $("#filterText").val().toUpperCase();
        $("tr.buchung").filterBuchung();
    }

    // nach Datums-Auswahl und Klick auf Button: Refresh mit Modus je nach Button:
    _refreshClick = function(event) {
        _refresh($(event.target).data("parm"));
    }
    _refresh = function(mode) {
        var _url = _reloadUrl;
        _url += "&select=" + $("#kontoId").val();
        _url += "&von=" + $("#vonDatum").val();
        _url += "&bis=" + $("#bisDatum").val();
        _url += "&mode=" + mode;
        if ($("#chkInaktive").prop("checked"))
            _url += "&inaktive=on";
        window.location = _url;
    }

    // bei Klick auf Expand--Icon --> entsprechendes Einblenden
    _expandClick = function(event) {
        var _td = $(event.target).parent("td"),
            _class = undefined,
        _endvar;
        _class = _td.data("open");
        $("tr." + _class).show();
        $(event.target).next("img").show();
        $(event.target).hide();
    }

    // bei Klick auf Collapse-Icon --> entsprechendes Ausblenden
    _collapseClick = function(event) {
        var _td = $(event.target).parent("td"),
            _class = undefined,
        _endvar;
        _class = _td.data("close");
        $("tr." + _class).hide();
        $(event.target).prev("img").show();
        $(event.target).hide();
    };

    // Kategorie-Regeln für Textvorschläge (neue Buchung) und On-the-fly-Anwendung laden:
    _loadRegeln = function() {
        var _request = undefined,
            _texte = [],
            _options = "",
            i = undefined,
        _endvar;

        _request = $.ajax({ url: _loadRegelnUrl, dataType: "json" });
        _request
            .done(function (data) {
                if (data.success != "yes") {
                    _showMessage(data.message);
                    return;
                }
                _regeln = data.regeln;
                for (i = 0; i < _regeln.length; i++)
                    _texte[i] = data.regeln[i].keyString;
                _texte.sort();
                for (i = 0; i < _texte.length; i++)
                    _options += "<option value=\"" + _texte[i] + "\"></option>";
                $("#texte").html(_options);
            })
            .fail(_requestFail);
    };

    // Bei Text-Änderung (neue Buchung) sofort Kategorie-Regeln anwenden:
    _textChange = function(event) {
        var i = undefined,
            _myText = $(event.target).val(),
        endvar;
        
        for (i = 0; i < _regeln.length; i++) {
            if (_myText.includes(_regeln[i].keyString)) {
                _regelKategId = _regeln[i].kategKey;
                $("#newOberKateg").val(_regeln[i].oberKategId);
                _newOberKategChange(event);
                return;
            }
        }
        _regelKategId = 0;
    };

    // bei Ändern der Oberkategorie für neue Buchung: Unterkategorie nachladen
    _newOberKategChange = function(event) {
        var _url = _getKategSelectUrl,
            _request = undefined,
        _endvar;

        _url += "?selectid=newUnterKateg&ID=" + $("#newOberKateg").val();
        _request = $.ajax({url: _url, dataType: "html"});
        _request
            .done(function(data){
                $("#divUnterKateg").html(data);
                if (_regelKategId > 0)
                    $("#newUnterKateg").val(_regelKategId);
            })
            .fail(_requestFail);
    };

    // Klick auf Action-Icon bei vorhandener Buchung
    _actionClick = function(event) {
        var _url = undefined,
            _action = undefined,
            _request = undefined,
        _endvar;
        _tdAction = $(event.target).parent("td");
        _action = $(event.target).data("action");
        if (_action == "delete") {
            $("#tdConfirmFrage").html("Willst du diese Buchung<br>wirklich l&ouml;schen?");
            $("#divDlgConfirm").show();
        } else if (_action == "edit") {
            _url = _editFormUrl + "?ID=" + _tdAction.data("buchungid");
            _request = $.ajax({url: _url, dataType: "html"});
            _request
                .done(function(data){
                    $("img.action").hide();
                    $("#dlgModal").html(data);
                    $("#divDialog").show();
                    $("#trNew").hide();
                    $("#showNew").show();
                    bc.buEditInit(_saveClick);
                })
                .fail(_requestFail);
        } else if (_action == "split") {
            _url = _splitUrl + "&ID=" + _tdAction.data("buchungid");
            window.location = _url;
        } else if (_action == "editSplit") {
            _url = _splitUrl + "&ID=" + $(event.target).data("ursprung");
            window.location = _url;
        }
    }

    // Nach Bestätigung einer Löschung: Löschen durchführen
    _deleteSure = function(event) {
        var _url = _buchungSaveUrl,
            _request = undefined,
        _endvar;
        _url += "?action=delete&ID=" + _tdAction.data("buchungid");
        _request = $.ajax({url: _url, dataType: "json"});
        _request
            .done(function(data){
                _showMessage(data.message);
                if (data.success == "yes")
                    window.location = _reloadUrl + "&select=" + $("#kontoId").val();
            })
            .fail(_requestFail);
};

    // Klick auf "speichern" bei Buchungs-Bearbeitung
    _saveClick = function(event) {
        var _url = _buchungSaveUrl,
            _trEdited = _tdAction.parent("tr"),
            _tdKateg = _tdAction.prev("td"),
            _tdSaldo = _tdKateg.prev("td"),
            _tdBetrag = _tdSaldo.prev("td"),
            _tdText = _tdBetrag.prev("td"),
            _tdDatum = _tdText.prev("td"),
            _request = undefined,
        _endvar;
        _url += "?action=save&" + bc.buEditSaveParams();
        _request = $.ajax({url: _url, dataType: "json"});
        _request
            .done(function(data){
                _showMessage(data.message);
                if (data.success == "yes") {
                    _tdDatum.html(data.datum);
                    _tdText.html(data.text);
                    _tdBetrag.html(data.betrag);
                    _tdSaldo.html("???");
                    _tdKateg.html(data.kateg);
                    _trEdited.data("filter", data.text + " " + data.kateg);
                    $("#divDialog").hide();
                    $("img.action").show();
                }
            })
            .fail(_requestFail);
    }

    // Klick auf "neu" für Buchung-Neuanlage
    _newClick = function(event) {
        var _url = _buchungSaveUrl,
            _request = undefined,
        _endvar;

        _url += "?action=save&ID=neu&datum=" + $("#newDatum").val() +
                "&text=" + $("#newText").val() + "&betrag=" + $("#newBetrag").val() +
                "&kategorie=" + $("#newUnterKateg").val() +
                "&konto=" + $("#kontoId").val();
        _request = $.ajax({url: _url, dataType: "json"});
        _request
            .done(function(data) {
                _showMessage(data.message);
                if (data.success == "yes")
                    _refresh("Chron");
            })
            .fail(_requestFail);
    }

    // Felder initialisieren
    $("div.shadow").hide();
    $("tr.hideFirst").hide();
    $("img.collapse").hide();
    $("#trNew").hide();
    bc.initDatumInput();
    // Eventhandler installieren
    $("button.refresh").on("click", _refreshClick);
    $("#filterText").on("keyup", _doFilter);
    $("#btnFilter").on("click", _doFilter);
    $("img.expand").on("click", _expandClick);
    $("img.collapse").on("click", _collapseClick);
    $("img.close").on("click", function(event) {
        $("div.shadow").hide();
        $("img.action").show();
    });
    $("#btnConfirmNo").on("click", function(event) {
        $("div.shadow").hide();
    });
    $("#btnConfirmYes").on("click", _deleteSure);
    $("#newOberKateg").on("change", _newOberKategChange);
    $("#btnNew").on("click", _newClick);
    $("img.action").on("click", _actionClick);
    $("#showNew").on("click", function(event) {
        _loadRegeln();
        $("#trNew").show();
        $("#showNew").hide();
    });
    $("#newText").on("keyup", _textChange);
    // Erstmalig Unterkategorien nachladen
    _newOberKategChange();
});