$(document).ready(function() {
    "use strict";
    var _reloadUrl = "main.php?open=planung&select=jahresplan",
        _editFormUrl = "service/getPlanPostenEditForm.php",
        _getKategSelectUrl = "./service/getKategSelect.php",
        _planPostenEditUrl = "./service/planpostenEdit.php",
        _showMessage = bc.showMessage,
        _requestFail = bc.requestFail,
        _kontoChange = function(){},
        _expandClick = function(){},
        _collapseClick = function(){},
        _actionClick = function(){},
        _editSaveClick = function(){},
    _endvar;

    // bei Ändern des Kontos oder Klick auf "Planen": neu laden
    _kontoChange = function(event) {
        window.location = _reloadUrl + "&konto=" + $("#selectKonto").val();
    }

    // bei Klick auf Expand--Icon --> entsprechendes Einblenden
    _expandClick = function(event) {
        var _td = $(event.target).parent("td"),
            _class = undefined,
        _endvar;
        _class = _td.data("open");
        $("tr." + _class).show();
        $(event.target).next("img").show();
        $(event.target).hide();
    }

    // bei Klick auf Collapse-Icon --> entsprechendes Ausblenden
    _collapseClick = function(event) {
        var _td = $(event.target).parent("td"),
            _class = undefined,
        _endvar;
        _class = _td.data("close");
        $("tr." + _class).hide();
        $(event.target).prev("img").show();
        $(event.target).hide();
    }

    // Klick auf Action-Icon bei vorhandener Plan-Buchung --> Planposten bearbeiten
    _actionClick = function(event) {
        var _url = undefined,
            _tdAction = undefined,
            _action = undefined,
            _request = undefined,
        _endvar;

        _tdAction = $(event.target).parent("td");
        _action = $(event.target).data("art");
        if (_action == "delete") {
            _url = _planPostenEditUrl +  "?action=delete&ID=" + _tdAction.data("id");
            _request = $.ajax({url: _url, dataType: "json"});
            _request
                .done(function(data) {
                    if (data.success == "yes")
                        _kontoChange();
                    else
                        _showMessage(data.message);
                })
                .fail(_requestFail);
        } else if (_action == "edit") {
            _url = _editFormUrl + "?modus=edit&ID=" + _tdAction.data("id");
            _request = $.ajax({url: _url, dataType: "html"});
            _request
                .done(function(data) {
                    $("div.dialog").html(data);
                    $("#divDialog").show();
                    bc.ppEditInit(_editSaveClick);
                })
                .fail(_requestFail);
            }
    }

    // Klick auf "speichern" im Bearbeitungs-Dialog
    _editSaveClick = function(event) {
        var _url = _planPostenEditUrl,
            _request = undefined,
        _endvar;
        _url += "?action=save&" + bc.ppEditSaveParams();
        _request = $.ajax({url: _url, dataType: "json"});
        _request
            .done(function(data) {
                if (data.success == "yes")
                    _kontoChange();
                else
                    _showMessage(data.message);
            })
            .fail(_requestFail);
    window.location = _reloadUrl +  + _urlFilterParam();
    }

    // Felder initialisieren
    $("div.shadow").hide();
    $("tr.hideFirst").hide();
    $("img.collapse").hide();
    // Eventhandler installieren
    $("#selectKonto").on("change", _kontoChange);
    $("#btnPlanen").on("click", _kontoChange);
    $("img.expand").on("click", _expandClick);
    $("img.collapse").on("click", _collapseClick);
    $("img.action").on("click", _actionClick);
    $("img.close").on("click", function(event) {
        $("div.shadow").hide();
    });
});