$(document).ready(function() {
    "use strict";
    var _reloadUrl = "main.php?open=planung&select=planposten",
        _editFormUrl = "service/getPlanPostenEditForm.php",
        _getKategSelectUrl = "./service/getKategSelect.php",
        _showMessage = bc.showMessage,
        _requestFail = bc.requestFail,
        _kontoChange = function(){},
        _filterOkChange = function(){},
        _doFiltering = function(){},
        _urlFilterParam = function(){},
        _newOkChange = function(){},
        _turnusArtChange = function(){},
        _actionClick = function(){},
        _editSaveClick = function(){},
        _newClick = function(){},
    _endvar;

    // bei Ändern des Kontos: neu laden
    _kontoChange = function(event) {
        window.location = _reloadUrl + "&konto=" + $("#selectKonto").val();
    }

    // bei Ändern der Kategorie-Filter: Filter ggf. adjustieren und Posten filtern
    _filterOkChange = function(event) {
        var _url = _getKategSelectUrl,
            _okVal = $("#filterOberKateg").val(),
            _request = undefined,
        _endvar;

        if (_okVal == "*") {
            $("#divFilterKateg").html("&nbsp;");
            _doFiltering();
        } else {
            _url += "?selectid=filterUnterKateg&ID=" + _okVal + "&selAll=true";
            _request = $.ajax({url: _url, dataType: "html"});
            _request
                .done(function(data){
                    $("#divFilterKateg").html(data);
                    $("#filterUnterKateg").on("change", _doFiltering);
                    _doFiltering();
                })
                .fail(_requestFail);
        }
    }
    _doFiltering = function() {
        var _okFilter = $("#filterOberKateg").val(),
            _ukFilter = $("#filterUnterKateg").val(),
        _endvar;

        if (_okFilter == "*")
            $("tr.data").show();
        else {
            $("tr.data").hide();
            if (_ukFilter == "*")
                $("tr.okat" + _okFilter).show();
            else
                $("tr.ukat" + _ukFilter).show();
        }
    }

    // Filter-Parameter für URL liefern
    _urlFilterParam = function() {
        var _res = "&konto=" + $("#selectKonto").val()
                + "&filterOberKateg=" + $("#filterOberKateg").val();
        if ($("#filterOberKateg").val() != "*")
            _res += "&filterUnterKateg=" + $("#filterUnterKateg").val();
        return _res;
    }

    // bei Ändern Oberkategorie in new-Zeile: passende Unterkategorien nachladen
    _newOkChange = function(event) {
        var _url = _getKategSelectUrl,
            _request = undefined,
        _endvar;

        _url += "?selectid=newUnterKateg&ID=" + $("#newOberKateg").val();
        _request = $.ajax({url: _url, dataType: "html"});
        _request
            .done(function(data){
                $("#divNewKateg").html(data);
            })
            .fail(_requestFail);
    }

    // bei Wechsel der Turnus-Art: Turnus-Count passend ein-/ausblenden
    _turnusArtChange = function(event) {
        if ($("#newTurnusArt").val() == "e") {
            $("#divNewTurnusCount").hide();
            $("#newEnde").val("31.12.2099").hide();
        } else {
            $("#divNewTurnusCount").show();
            $("#newEnde").show();
        }
    }

    // Klick auf Action-Icon bei vorhandenem Planposten
    _actionClick = function(event) {
        var _url = undefined,
            _tdAction = undefined,
            _action = undefined,
            _request = undefined,
        _endvar;

        _tdAction = $(event.target).parent("td");
        _action = $(event.target).data("art");
        if (_action == "delete") {
            _url = _reloadUrl +  "&action=" + _action + "&ID=" + _tdAction.data("id");
            window.location = _url + _urlFilterParam();
        } else if (_action == "edit") {
            _url = _editFormUrl + "?modus=edit&ID=" + _tdAction.data("id");
            _request = $.ajax({url: _url, dataType: "html"});
            _request
                .done(function(data) {
                    $("div.dialog").html(data);
                    $("#divDialog").show();
                    bc.ppEditInit(_editSaveClick);
                })
                .fail(_requestFail);
            }
    }

    // Klick auf "speichern" im Bearbeitungs-Dialog
    _editSaveClick = function(event) {
        window.location = _reloadUrl + "&action=edit&" + bc.ppEditSaveParams() + _urlFilterParam();
    }

    // Klick auf "neu" für Buchung-Neuanlage
    _newClick = function(event) {
        var _url = _reloadUrl,
        _endvar;

        _url += "&action=new&text=" + $("#newPostenText").val() +
            "&kategorie=" + $("#newUnterKateg").val() +
            "&betrag=" + $("#newBetrag").val() +
            "&beginn=" + $("#newBeginn").val() +
            "&ende=" + $("#newEnde").val() +
            "&turnusArt=" + $("#newTurnusArt").val() +
            "&turnusCount=" + $("#newTurnusCount").val();
        window.location = _url + _urlFilterParam();
    }

    // Felder initialisieren
    $("div.shadow").hide();
    $("#divNewTurnusCount").hide();
    $("#newEnde").hide();
    bc.initDatumInput();
    // Eventhandler installieren
    $("#filterOberKateg").on("change", _filterOkChange);
    $("#selectKonto").on("change", _kontoChange);
    $("#newOberKateg").on("change", _newOkChange);
    $("#newTurnusArt").on("change", _turnusArtChange);
    $("#btnNew").on("click", _newClick);
    $("img.action").on("click", _actionClick);
    $("img.close").on("click", function(event) {
        $("div.shadow").hide();
    });
    // Erstmalig Unterkategorien für new-Zeile nachladen
    _newOkChange();
    // Ggf. Initial-Filter einstellen
    _filterOkChange();
    if ($("#filterOberKateg").val() != "*") {
        $("#filterUnterKateg").val($("#divFilterKateg").data("init"));
        _doFiltering();
    }
});