$(document).ready(function() {
    "use strict";
    var _reloadUrl = "main.php?open=planung&select=sollist",
        _editFormUrl = "service/getPlanPostenEditForm.php",
        _ppSaveUrl = "service/planpostenSave.php",
        _ppEditUrl = "service/planpostenEdit.php",
        _showMessage = bc.showMessage,
        _requestFail = bc.requestFail,
        _deleteId = undefined,
        _kontoChange = function(){},
        _planeNeu = function(){},
        _imgClick = function(){},
        _expandClick = function(){},
        _collapseClick = function(){},
        _ppBearbClick = function(){},
        _deleteClick = function(){},
        _deleteSure = function(){},
        _ppSaveClick = function(){},
    _endvar;

    // bei Ändern des Kontos: neu laden
    _kontoChange = function(event) {
        window.location = _reloadUrl + "&konto=" + $("#selectKonto").val();
    }

    // bei Klick auf "Planung erstellen": Neuaufbau mit eingestelltem Zeitraum
    _planeNeu = function(event) {
        window.location = _reloadUrl + "&konto=" + $("#selectKonto").val() +
            "&von=" + $("#vonDatum").val() + "&bis=" + $("#bisDatum").val();
    }

    // Event-Verteiler bei Klick auf Img in Buchungs-Tabelle
    _imgClick = function(event) {
        var _imgArt = $(event.target).data("art");

        if (_imgArt == "expand")
            _expandClick(event);
        else if (_imgArt == "collapse")
            _collapseClick(event);
        else if (_imgArt == "convert")
            _ppBearbClick(event, "newFromBuchung");
        else if (_imgArt == "edit")
            _ppBearbClick(event, "edit");
        else if (_imgArt == "delete")
            _deleteClick(event);
    }

    // bei Klick auf Expand--Icon --> entsprechendes Einblenden
    _expandClick = function(event) {
        var _td = $(event.target).parent("td"),
            _class = undefined,
        _endvar;
        _class = _td.data("open");
        $("tr." + _class).show();
        $(event.target).next("img").show();
        $(event.target).hide();
    }

    // bei Klick auf Collapse-Icon --> entsprechendes Ausblenden
    _collapseClick = function(event) {
        var _td = $(event.target).parent("td"),
            _class = undefined,
        _endvar;
        _class = _td.data("close");
        $("tr." + _class).hide();
        $(event.target).prev("img").show();
        $(event.target).hide();
    }

    // bei Klick auf Convert-Icon --> Planposten aus Konto-Buchung erstellen
    // bei Klick auf Edit-Icon --> der Plan-Buchung zugrunde liegenden Planposten bearbeiten
    _ppBearbClick = function(event, modus) {
        var _url = _editFormUrl,
            _request = undefined,
        _endvar;

        _url += "?modus=" + modus + "&ID=" + $(event.target).parent("td").data("id");
        _request = $.ajax({url: _url, dataType: "html"});
        _request
            .done(function(data) {
                $("div.dialog").html(data);
                $("#divDialog").show();
                bc.ppEditInit(_ppSaveClick);
            })
            .fail(_requestFail);
    }

    // bei Klick auf "speichern" in Planposten-Bearbeitungs-Dialog: Speichern-Service aufrufen
    _ppSaveClick = function(event) {
        var _url = _ppSaveUrl,
            _request = undefined,
        _endvar;

        _url += "?" + bc.ppEditSaveParams();
        _request = $.ajax({url: _url, dataType: "json"});
        _request
            .done(function(data) {
                _showMessage(data.message);
                if (data.success == "yes")
                    $("#divDialog").hide();
            })
            .fail(_requestFail);
    }

    // bei Klick auf Delete-Icon --> der Plan-Buchung zugrunde liegenden Planposten löschen
    _deleteClick = function(event) {
        _deleteId = $(event.target).parent("td").data("id");
        $("#tdConfirmFrage").html("Willst du diesen Planungs-Posten<br>wirklich l&ouml;schen?");
        $("#divDlgConfirm").show();
    }

    // bei Bestätigung der Löschen-Rückfrage: Lösch-Service und anschließend Planungs-Refresh
    _deleteSure = function(event) {
        var _url = _ppEditUrl,
            _request = undefined,
        _endvar;

        _url += "?action=delete&ID=" + _deleteId;
        _request = $.ajax({url: _url, dataType: "json"});
        _request
            .done(function(data) {
                _showMessage(data.message);
                if (data.success == "yes")
                    _planeNeu(event);
            })
            .fail(_requestFail);
    }

    // Felder initialisieren
    $("div.shadow").hide();
    $("tr.hideFirst").hide();
    $("img.collapse").hide();
    bc.initDatumInput();
    // Eventhandler installieren
    $("#selectKonto").on("change", _kontoChange);
    $("#btnPlanen").on("click", _planeNeu);
    $("#tblBuchungen").on("click", "img", _imgClick)
    $("#btnConfirmYes").on("click", _deleteSure);
    $("img.close").on("click", function(event) {
        $("div.shadow").hide();
    });
});