$(document).ready(function() {
    "use strict";
    var _reloadUrl = "main.php?open=konto&select=split",
        _getKategSelectUrl = "./service/getKategSelect.php",
        _loadRegelnUrl = "service/loadRegeln.php",
        _showMessage = bc.showMessage,
        _requestFail = bc.requestFail,
        _regeln = undefined,
        _regelKategId = 0,
        _loadRegeln = function(){},
        _oberKategChange = function(){},
        _textChange = function(){},
        _actionClick = function(){},
        _newClick = function(){},
    _endvar;

    // Kategorie-Regeln für Textvorschläge und On-the-fly-Anwendung laden:
    _loadRegeln = function() {
        var _request = undefined,
            _texte = [],
            _options = "",
            i = undefined,
        _endvar;

        _request = $.ajax({ url: _loadRegelnUrl, dataType: "json" });
        _request
            .done(function (data) {
                if (data.success != "yes") {
                    _showMessage(data.message);
                    return;
                }
                _regeln = data.regeln;
                for (i = 0; i < _regeln.length; i++)
                    _texte[i] = data.regeln[i].keyString;
                _texte.sort();
                for (i = 0; i < _texte.length; i++)
                    _options += "<option value=\"" + _texte[i] + "\"></option>";
                $("#texte").html(_options);
            })
            .fail(_requestFail);
    };

    // bei Ändern der Oberkategorie für neue Buchung: Unterkategorie nachladen
    _oberKategChange = function(event) {
        var _url = _getKategSelectUrl,
            _request = undefined,
        _endvar;

        _url += "?ID=" + $("#newOberKateg").val() +
                "&selectid=newUnterKateg";

        _request = $.ajax({url: _url, dataType: "html"});
        _request
            .done(function(data){
                $("#divUnterKateg").html(data);
                if (_regelKategId > 0)
                    $("#newUnterKateg").val(_regelKategId);
            })
            .fail(_requestFail);
    };

    // Bei Text-Änderung sofort Kategorie-Regeln anwenden:
    _textChange = function(event) {
        var i = undefined,
            _myText = $(event.target).val(),
        endvar;
        
        for (i = 0; i < _regeln.length; i++) {
            if (_myText.includes(_regeln[i].keyString)) {
                _regelKategId = _regeln[i].kategKey;
                $("#newOberKateg").val(_regeln[i].oberKategId);
                _oberKategChange(event);
                return;
            }
        }
        _regelKategId = 0;
    };

    // Klick auf Action-Icon bei vorhandener Buchung
    _actionClick = function(event) {
        var _url = _reloadUrl,
            _action = undefined,
        _endvar;

        _action = $(event.target).data("action");
        if (_action == "delete")
            _url += "&action=delete&ID="  + $("#ursprungId").val() +
                   "&delID=" + $(event.target).parent("td").data("buchungid");
        else
            return;
        window.location = _url;
    };

    // Klick auf "neu" für Teilbuchung-Neuanlage
    _newClick = function(event) {
        window.location = _reloadUrl + "&action=new&ID=" + $("#ursprungId").val() +
                "&text=" + $("#newText").val() + "&betrag=" + $("#newBetrag").val() +
                "&kategorie=" + $("#newUnterKateg").val();
    };

    // Eventhandler installieren
    $("#newOberKateg").on("change", _oberKategChange);
    $("#btnNew").on("click", _newClick);
    $("img.action").on("click", _actionClick);
    $("#newText").on("keyup", _textChange);
    // Kategorie-Regeln holen
    _loadRegeln();
    // Erstmalig Unterkategorien nachladen
    _oberKategChange();
});