<?php
    // Aktion für Speichern Buchungs-Daten durchführen
    session_start();
    require("./_basics.php");
    require("../control/KontoManager.php");
    require("../model/ME_Saldo.php");
    
    Sql::dbInit();
    if (!BC_checkSession())
        BC_sayAndDie("Keine g&uuml;ltige Anmeldung!");

    $res = array();
    $res["success"] = "no";

    Input::setSource("get");
    $id = Input::getString("ID");
    $action = Input::getString("action");
    $changeDatum = new Datum("");
    $konto = null;
    
    if ($action == "delete") {
        $buchung = Buchung::findById($id);
        if (is_null($buchung))
            $res["message"] = "Fehler: Buchung nicht vorhanden.";
        else {
            $konto = $buchung->getKonto();
            $changeDatum->set($buchung->getDatum()->getDbFormat());
            $buchung->delete();
            $res["message"] = "Buchung wurde gelöscht.";
            $res["success"] = "yes";
        }
    } else if ($action == "save") {
        if ($id == "neu")
            $buchung = Buchung::neu();
        else
            $buchung = Buchung::findById($id);

        if (is_null($buchung))
            GlobalVars::push("messages", "Fehler: Buchung nicht vorhanden.");
        else {
            $changeDatum->set($buchung->getDatum()->getDbFormat());
            $konto = Konto::findById(Input::getNumber("konto"));
            $kateg = Kategorie::findById(Input::getNumber("kategorie"));
            if (is_null($konto))
                GlobalVars::push("messages", "Fehler: Konto nicht vorhanden.");
            else if (is_null($kateg))
                GlobalVars::push("messages", "Fehler: Kategorie nicht vorhanden.");
            else {
                $buchung->setKategorie($kateg);
                $buchung->setKonto($konto);
                $buchung->setStatus("a");
                $buchung->setDatum(new Datum(Input::getString("datum")));
                $buchung->setBetrag(Input::getBetrag("betrag"));
                $buchung->setText(Input::getString("text"));
                $buchung->save();
                if ($buchung->getDatum()->isBefore($changeDatum))
                    $changeDatum->set($buchung->getDatum()->getDbFormat());
                $res["datum"] = $buchung->getDatum()->getDispFormat();
                $res["text"] = $buchung->getText();
                $res["betrag"] = BC_moneyFormat($buchung->getBetrag())." &euro;";
                $res["kateg"] = $kateg->getBezeichnung();
                $res["message"] = "Daten wurden gespeichert - Refresh für Salden-Aktualisierung.";
                $res["success"] = "yes";
            }
        }
    } else
        $res["message"] = "Fehler: unbekannter Action-Code ".$action;

    if ($res["success"] == "yes")
        KontoManager::aktualisiereSalden($konto, $changeDatum);

    echo json_encode($res);
    Sql::dbClose();
?>