<?php
    // Aktion für Speichern importierter Buchungen durchführen --> accept oder delete
    // --> bei accept: Regeln zur Kategorie-Zuordnung anwenden
    session_start();
    require("./_basics.php");
    require("../model/Regel.php");
    require("../model/ME_Saldo.php");
    require("../control/KontoManager.php");
    
    Sql::dbInit();
    if (!BC_checkSession())
        BC_sayAndDie("Keine g&uuml;ltige Anmeldung!");

    $res = array();
    $res["success"] = "no";

    Input::setSource("get");
    $id = Input::getString("ID");
    $action = Input::getString("action");
    
    $b = Buchung::findById($id);
    if (is_null($b))
        $res["message"] = "Fehler: Buchung nicht vorhanden.";
    else if ($action == "delete") {
        $b->delete();
        $res["message"] = "Buchung wurde gelöscht.";
        $res["success"] = "yes";
    } else if ($action == "accept") {
        $b->setStatus("a");
        $b->setText(Input::getString("text"));
        $kategId = Input::getNumber("kategorie");
        if ($kategId > 0)
            $b->setKategorie(Kategorie::findById($kategId));
        $b->save();
        KontoManager::aktualisiereSalden($b->getKonto(), $b->getDatum());
        $res["message"] = "Buchung wurde übernommen.";
        $m = new Monat($b->getDatum());                    // *** Trace
        $mes = ME_Saldo::getForMonat($b->getKonto(), $m);  // *** Trace
        //BC_trace("Akzeptiert: Buchung ".$b->getId()."(".$b->getDatum()->getDispFormat().") --> ME-Saldo: ".$mes->getSaldo());   // *** Trace
        $res["success"] = "yes";
    } else
        $res["message"] = "Fehler: unbekannter Action-Code ".$action;

    echo json_encode($res);
    Sql::dbClose();
?>