<?php
    // Aktion für Speichern Kategorie-Daten durchführen
    session_start();
    require("./_basics.php");
    require("../model/Regel.php");
    require("../control/KategorieManager.php");
    
    Sql::dbInit();
    if (!BC_checkSession())
        BC_sayAndDie("Keine g&uuml;ltige Anmeldung!");

    $res = array();
    $res["success"] = "no";

    Input::setSource("get");
    $id = Input::getString("ID");
    $action = Input::getString("action");
    
    if ($action == "delete") {
        $kateg = Kategorie::findById($id);
        if (is_null($kateg))
            $res["message"] = "Fehler: Kategorie nicht vorhanden.";
        else if (KategorieManager::kategWirdVerwendet($kateg))
            $res["message"] = "Fehler: Kategorie wird verwendet.";
        else {
            $kateg->delete();
            $res["message"] = "Kategorie wurde gelöscht.";
            $res["success"] = "yes";
        }
    } else if ($action == "save") {
        if ($id == "neu") {
            $kateg = Kategorie::neu();
            $kateg->setArt(Input::getString("art"));
            if ($kateg->istUnterKategorie())
                $kateg->setParent(Kategorie::findById(Input::getNumber("parent")));
        } else
            $kateg = Kategorie::findById($id);

        if (is_null($kateg))
            GlobalVars::push("messages", "Fehler: Kategorie nicht vorhanden.");
        else {
            $kateg->setBezeichnung(Input::getString("bez"));
            $kateg->setSort(Input::getNumber("sort"));
            $kateg->setAktiv(Input::isChecked("aktiv"));
            $kateg->save();
            $res["message"] = "Daten wurden gespeichert.";
            $res["success"] = "yes";
        }
    } else
        $res["message"] = "Fehler: unbekannter Action-Code ".$action;

    echo json_encode($res);
    Sql::dbClose();
?>