<?php
    // Aktion für Speichern Regel-Daten durchführen
    session_start();
    require("./_basics.php");
    require("../model/Regel.php");
    
    Sql::dbInit();
    if (!BC_checkSession())
        BC_sayAndDie("Keine g&uuml;ltige Anmeldung!");

    $res = array();
    $res["success"] = "no";

    Input::setSource("get");
    $id = Input::getString("ID");
    $action = Input::getString("action");
    
    if ($action == "delete") {
        $regel = Regel::findById($id);
        if (is_null($regel))
            $res["message"] = "Fehler: Regel nicht vorhanden.";
        else {
            $regel->delete();
            $res["message"] = "Regel wurde gelöscht.";
            $res["success"] = "yes";
        }
    } else if ($action == "save") {
        if ($id == "neu")
            $regel = Regel::neu();
        else
            $regel = Regel::findById($id);

        if (is_null($regel))
            GlobalVars::push("messages", "Fehler: Regel nicht vorhanden.");
        else {
            $kateg = Kategorie::findById(Input::getNumber("kategorie"));
            $regel->setKeyString(Input::getString("keyString"));
            $regel->setKategorie($kateg);
            $regel->setSort(Input::getNumber("sort"));
            $regel->save();
            $res["kategBez"] = $kateg->getBezeichnung();
            $res["message"] = "Daten wurden gespeichert.";
            $res["success"] = "yes";
        }
    } else
        $res["message"] = "Fehler: unbekannter Action-Code ".$action;

    echo json_encode($res);
    Sql::dbClose();
?>