<?php

class Input {
    private static $source = array();

    // Hochkomma und Spitzklammer eliminieren, UTF-8-Codierung sicherstellen
    static function fixCoding($s) {
        if (mb_detect_encoding($s, "UTF-8, ISO-8859-1, ASCII", true) != "UTF-8")
            $s1 = utf8_encode($s);
        else
            $s1 = $s;
        $s1 = str_replace("'", "&apos;", $s1);
        $s1 = str_replace('"', "&quot;", $s1);
        return str_replace("<", "&lt;", $s1);
    }

    static function setSource($src) {
        if ($src == "get")
            self::$source = $_GET;
        else if ($src == "post")
            self::$source = $_POST;
        else
            self::$source = array();
    }
    static function getString($name) {
        if (!isset(self::$source[$name]))
            return "";
        return self::fixCoding(self::$source[$name]);
    }
    static function getOrigString($name) {
        if (!isset(self::$source[$name]))
            return "";
        return self::$source[$name];
    }
    static function getNumber($name) {
        if (!isset(self::$source[$name]))
            return 0;
        $val = self::$source[$name];
        if ($val == "")
            return 0;
        if(!is_numeric($val))
            return 0;
        return $val;
    }
    static function getBetrag($name) {
        if (!isset(self::$source[$name]))
            return 0;
        $val = self::$source[$name];
        $parts = explode(".", $val);
        if (count($parts) == 2 && strlen($parts[1]) == 2)
            return $val;
        $val = str_replace(".", "", $val);
        return str_replace(",", ".", $val);
    }
    static function isChecked($name) {
        if (isset(self::$source[$name]))
            return true;
        return false;
    }
    static function isPresent($name) {
        return self::isChecked($name);
    }
    static function getOption($name) {
        if (!isset(self::$source[$name]))
            return "";
      return self::fixCoding(self::$source[$name][0]);
    }
    static function getParam($name) {
        if (isset($_GET[$name]))
            return self::fixCoding($_GET[$name]);
        if (isset($_POST[$name]))
            return self::fixCoding($_POST[$name]);
        return "";
    }
} // Ende Klasse Input
?>
