<?php
    // Verwendete Icons von webtoolhub.com (blue-buttons-aha-soft)
    // --> http://icons.webtoolhub.com/icon-p0s2269-set.aspx

    // Selektions-Klassen für Menü und Item festlegen:
    $menuClass = array(
        "konto" => "",
        "import" => "",
        "planung" => "",
        "admin" => "",
        "help" => ""
    );
    $menuClass[GlobalVars::getVar("menuOpen")] = " open";
    $itemClass = array(
        "dashboard" => "",
        "csv" => "",
        "voba" => "",
        "diba" => "",
        "xml" => "",
        "planposten" => "",
        "sollist" => "",
        "predict" => "",
        "jahresplan" => "",
        "bereinigen" => "",
        "konten" => "",
        "kategorien" => "",
        "regeln" => "",
        "textregeln" => "",
        "backupRestore" => "",
        "help" => "",
        "releasenotes" => "",
        "readme" => ""
    );
    $konten = Konto::getAll();
    foreach ($konten as $ix => $k)
        $itemClass["kto".$k->getId()] = "";
    $itemClass[GlobalVars::getVar("itemSelected")] = " selected";
?>
<aside class="nav">
    <!-- ***** Konten-Menü ***** -->
    <div class="menu<?=$menuClass["konto"]?>" data-menu="menuKonto">
        <img src="img/menuKonto.png">
        <p>Konto</p>
    </div>
    <div class="subMenu menuKonto">
        <div class="menu item<?=$itemClass["dashboard"]?>"
            data-url="main.php?open=konto&select=dashboard">
            <p>Übersicht</p>
        </div>

<?php
    foreach ($konten as $ix => $k) {
        $class = "kto".$k->getId();
?>
        <div class="menu item<?=$itemClass[$class]?>"
            data-url="main.php?open=konto&select=<?=$k->getId()?>">
            <p><?=$k->getBezeichnung()?></p>
        </div>
<?php
    }
?>
    </div>
    <!-- ***** Import-Menü ***** -->
    <div class="menu<?=$menuClass["import"]?>" data-menu="menuImport">
        <img src="img/menuImport.png">
        <p>Import</p>
    </div>
    <div class="subMenu menuImport">
        <div class="menu item<?=$itemClass["csv"]?>"
            data-url="main.php?open=import&select=csv">
            <p>CSV-Datei</p>
        </div>
        <div class="menu item<?=$itemClass["voba"]?>"
            data-url="main.php?open=import&select=voba">
            <p>VoBa-Export</p>
        </div>
        <div class="menu item<?=$itemClass["diba"]?>"
            data-url="main.php?open=import&select=diba">
            <p>ING DiBa-Export</p>
        </div>
        <div class="menu item<?=$itemClass["xml"]?>"
            data-url="main.php?open=import&select=xml">
            <p>XML-Datei</p>
        </div>
    </div>
    <!-- ***** Planungs-Menü ***** -->
    <div class="menu<?=$menuClass["planung"]?>" data-menu="menuPlanung">
        <img src="img/menuPlanung.png">
        <p>Planung</p>
    </div>
    <div class="subMenu menuPlanung">
    <div class="menu item<?=$itemClass["planposten"]?>"
            data-url="main.php?open=planung&select=planposten">
            <p>Planposten pflegen</p>
        </div>
        <div class="menu item<?=$itemClass["sollist"]?>"
            data-url="main.php?open=planung&select=sollist">
            <p>Vergleich Plan vs. Konto</p>
        </div>
        <div class="menu item<?=$itemClass["predict"]?>"
            data-url="main.php?open=planung&select=predict">
            <p>Prognose Konto-Verlauf</p>
        </div>
        <div class="menu item<?=$itemClass["jahresplan"]?>"
            data-url="main.php?open=planung&select=jahresplan">
            <p>Jahres-Plan</p>
        </div>
        <div class="menu item<?=$itemClass["bereinigen"]?>"
            data-url="main.php?open=planung&select=bereinigen">
            <p>Planung bereinigen</p>
        </div>
    </div>
    <!-- ***** Admin-Menü ***** -->
    <div class="menu<?=$menuClass["admin"]?>" data-menu="menuAdmin">
        <img src="img/menuAdmin.png">
        <p>Administration</p>
    </div>
    <div class="subMenu menuAdmin">
        <div class="menu item<?=$itemClass["konten"]?>"
            data-url="main.php?open=admin&select=konten">
            <p>Konten</p>
        </div>
        <div class="menu item<?=$itemClass["kategorien"]?>"
            data-url="main.php?open=admin&select=kategorien">
            <p>Kategorien</p>
        </div>
        <div class="menu item<?=$itemClass["regeln"]?>"
            data-url="main.php?open=admin&select=regeln">
            <p>Regeln</p>
        </div>
        <div class="menu item<?=$itemClass["textregeln"]?>"
            data-url="main.php?open=admin&select=textregeln">
            <p>Text-Regeln</p>
        </div>
        <div class="menu item<?=$itemClass["backupRestore"]?>"
            data-url="main.php?open=admin&select=backupRestore">
            <p>Backup/Restore</p>
        </div>
    </div>
    <!-- ***** Hilfe-Menü ***** -->
    <div class="menu<?=$menuClass["help"]?>" data-menu="menuHelp">
        <img src="img/menuHelp.png">
        <p>Hilfe / Info</p>
    </div>
    <div class="subMenu menuHelp">
        <div class="menu item<?=$itemClass["help"]?>"
            data-url="doc/Hilfe.pdf">
            <p>Info-Dokument</p>
        </div>
        <div class="menu item<?=$itemClass["releasenotes"]?>"
            data-url="doc/ReleaseNotes.pdf">
            <p>Release Notes</p>
        </div>
        <div class="menu item<?=$itemClass["readme"]?>"
            data-url="Readme.html">
            <p>Readme-Dokument</p>
        </div>
    </div>
</aside>