<?php
    // Main-Element für Planungs-Seite Select: planposten
    $kontoParm = Input::getString("konto");
    if ($kontoParm == "")
        $konto = Konto::getAny();
    else
        $konto = Konto::findById($kontoParm);
    
    $okFilter = Input::getString("filterOberKateg");
    if ($okFilter == "")
        $okFilter = "*";
    $ukFilter = Input::getString("filterUnterKateg");
        if ($ukFilter == "")
            $ukFilter = "*";
    
    $kListe = Konto::getAll();
    $pListe = Planposten::getForKonto($konto);
    $oKatListe = Kategorie::getOberKategorien();
    $turnusSelect = PlanPosten::getTurnusListe();
    $heute = new Datum("");
?>
<main role="main" class="relative">
    <?php require("view/displayMessage.php"); ?>

    <table class="form">
        <tr>
            <td>
                Konto:
                <select id="selectKonto">
                    <?=BC_makeHtmlOptions($kListe, $konto->getId(), false)?>
                </select>
            </td>
            <td>
                Kategorie-Filter:
                <select id="filterOberKateg">
                    <?=BC_makeHtmlOptions($oKatListe, $okFilter, true)?>
                </select>
            </td>
            <td>
                <div id="divFilterKateg" data-init="<?=$ukFilter?>">&nbsp;</div>
            </td>
        </tr>
    </table>

    <table class="form">
        <tr>
            <th>Text</th>
            <th>Kategorie</th>
            <th>Betrag</th>
            <th>Beginn</th>
            <th>Ende</th>
            <th>Turnus</th>
            <th>Aktion</th>
        </tr>
<?php
    foreach ($pListe as $ix => $p) {
        $kateg = $p->getKategorie();
        $ok = $kateg->getParent();
        $betrag = $p->getBetrag();
        if ($betrag < 0)
            $bClass = " negativ";
        else
            $bClass = "";
        if ($p->getTurnusArt() == "e")
            $bis = "&nbsp;";
        else
            $bis = $p->getEnde()->getDispFormat();
?>
        <tr class="data okat<?=$ok->getId()?> ukat<?=$kateg->getId()?>">
            <td><?=$p->getText()?></td>
            <td><?=$kateg->getBezeichnung()?></td>
            <td class="betrag<?=$bClass?>"><?=BC_moneyFormat($betrag)?> &euro;</td>
            <td><?=$p->getBeginn()->getDispFormat()?></td>
            <td><?=$bis?></td>
            <td><?=$p->getTurnusText()?></td>
            <td data-id="<?=$p->getId()?>">
                <img class="action" data-art="edit" src="./img/edit.png">
                <img class="action" data-art="delete" src="./img/delete.png">
            </td>
        </tr>
<?php
    } // end foreach
?>
        <tr id="trNew">
            <td><input id="newPostenText" size="40" value="" placeholder="neuer Planposten - Text"></td>
            <td>
                <select id="newOberKateg">
                    <?=BC_makeHtmlOptions($oKatListe, 1, false)?>
                </select>
                <div id="divNewKateg">&nbsp;</div>
            </td>
            <td><input id="newBetrag" size="7" value="0,00"> &euro;</td>
            <td><input id="newBeginn" class="datum" size="10" value="<?=$heute->getDispFormat()?>" readonly></td>
            <td><input id="newEnde" class="datum" size="10" value="31.12.2099" readonly></td>
            <td><div id="divNewTurnusCount">
                    alle <input id="newTurnusCount" size="5" value="1">
                </div>&nbsp;
                <select id="newTurnusArt">
                    <?=BC_makeHtmlOptions($turnusSelect, "e", false)?>
                </select>
            </td>
            <td><button id="btnNew">neu</button></td>
        </tr>
    </table>
</main>