<?php
    // Main-Element für Bearbeitung Buchungs-Splitting
    $uBuchung = GlobalVars::getVar("Buchung");
    $ubListe = $uBuchung->getTeilbuchungen();

    $uBetrag = $uBuchung->getBetrag();
    if ($uBetrag < 0)
        $bClass = " negativ";
    else
        $bClass = "";
    $k = $uBuchung->getKategorie();
    if (is_null($k))
        $kBez = "-null-";
    else
        $kBez = $k->getBezeichnung();
    $tBetrag = $uBetrag;
?>
<main role="main" class="relative">
    <?php require("view/displayMessage.php"); ?>

    <table class="form">
        <tr>
            <th>Datum</th>
            <th>Text</th>
            <th>Betrag</th>
            <th>Kategorie</th>
            <th>Aktion</th>
        </tr>
        <tr>
            <th class="top" colspan="5">Ursprungs-Buchung</th>
        </tr>
        <tr>
            <td><?=$uBuchung->getDatum()->getDispFormat()?></td>
            <td><?=$uBuchung->getText()?></td>
            <td class="betrag<?=$bClass?>"><?=BC_moneyFormat($uBetrag)?> &euro;</td>
            <td><?=$kBez?></td>
            <td><input type="hidden" id="ursprungId" value="<?=$uBuchung->getId()?>"></td>
        </tr>
        <tr>
            <th class="top" colspan="5">Teil-Buchungen</th>
        </tr>
<?php
    foreach ($ubListe as $ix => $b) {
        $betrag = $b->getBetrag();
        $tBetrag -= $betrag;
        if ($betrag < 0)
            $bClass = " negativ";
        else
            $bClass = "";
        $k = $b->getKategorie();
        if (is_null($k))
            $kBez = "-null-";
        else
            $kBez = $k->getBezeichnung();
?>
        <tr>
            <td>&nbsp;</td>
            <td><?=$b->getText()?></td>
            <td class="betrag<?=$bClass?>"><?=BC_moneyFormat($betrag)?> &euro;</td>
            <td><?=$kBez?></td>
            <td data-buchungid="<?=$b->getId()?>">
                <img class="action" data-action="delete" src="./img/delete.png">
            </td>
        </tr>
<?php
    } // Ende foreach (Teilbuchung)

    $tBetrag = round($tBetrag, 2);
    if ($tBetrag == 0) { 
?>
        <tr>
            <td class="center" colspan="5">
                <a href="main.php?open=konto&select=<?=$uBuchung->getKonto()->getId()?>">
                    <button type="button">fertig</button>
                </a>
            </td>
        </tr>
<?php 
    }  else { 
        // Neue Buchung mit offenem Teilbetrag vorbelegen
        if ($tBetrag < 0)
            $bClass = " negativ";
        else
            $bClass = "";
        $oKatListe = Kategorie::getOberKategorien();
?>
        <tr>
            <th class="top" colspan="5">Rest-Betrag aufteilen</th>
        </tr>
        <tr id="trNew">
            <td>&nbsp;</td>
            <td><input id="newText" size="30" value="" placeholder="neue Buchung" list="texte"></td>
            <td><input id="newBetrag" size="10" value="<?=BC_moneyFormat($tBetrag)?>"></td>
            <td>
                <select id="newOberKateg">
                    <?=BC_makeHtmlOptions($oKatListe, 1, false)?>
                </select>
                <div id="divUnterKateg">&nbsp;</div>
            </td>
            <td>
                <button id="btnNew" type="button">neu</button>
            </td>
        </tr>
        <tr>
            <td colspan="5" class="warning">Bitte vollst&auml;ndige Aufteilung vornehmen!</td>
        </tr>
<?php 
    }
?>
    </table>
    <datalist id="texte"></datalist>
</main>